/*
 *
 * Copyright  1990-2006 Sun Microsystems, Inc. All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 only, as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details (a copy is
 * included at /legal/license.txt). 
 * 
 * You should have received a copy of the GNU General Public License
 * version 2 along with this work; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA 
 * 
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
 * Clara, CA 95054 or visit www.sun.com if you need additional
 * information or have any questions. 
 */
package com.sun.midp.chameleon.skins;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Image;

/**
 * DateEditorSkin represents the properties and values used to render
 * the popup editor for the DateField component in the 
 * javax.microedition.lcdui package.
 */
public class DateEditorSkin {
    
    /**
     * This field corresponds to DATEEDITOR_HEIGHT skin property.
     * See its comment for further details.
     */
    public static int HEIGHT;

    /**
     * This field corresponds to DATEEDITOR_HEIGHT_POPUPS skin property.
     * See its comment for further details.
     */
    public static int HEIGHT_POPUPS;

    /**
     * This field corresponds to DATEEDITOR_WIDTH_D skin property.
     * See its comment for further details.
     */
    public static int WIDTH_DATE;

    /**
     * This field corresponds to DATEEDITOR_WIDTH_T skin property.
     * See its comment for further details.
     */
    public static int WIDTH_TIME;

    /**
     * This field corresponds to DATEEDITOR_WIDTH_DT skin property.
     * See its comment for further details.
     */
    public static int WIDTH_DATETIME;

    /**
     * This field corresponds to DATEEDITOR_COLOR_BG skin property.
     * See its comment for further details.
     */
    public static int COLOR_BG;

    /**
     * This field corresponds to DATEEDITOR_COLOR_POPUPS_BG skin property.
     * See its comment for further details.
     */
    public static int COLOR_POPUPS_BG;

    /**
     * This field corresponds to DATEEDITOR_COLOR_BRDR skin property.
     * See its comment for further details.
     */
    public static int COLOR_BORDER;

    /**
     * This field corresponds to DATEEDITOR_COLOR_TRAV_IND skin property.
     * See its comment for further details.
     */
    public static int COLOR_TRAVERSE_IND;

    /**
     * This field corresponds to DATEEDITOR_COLOR_CLK_LT skin property.
     * See its comment for further details.
     */
    public static int COLOR_CLOCKHAND_LT;

    /**
     * This field corresponds to DATEEDITOR_COLOR_CLK_DK skin property.
     * See its comment for further details.
     */
    public static int COLOR_CLOCKHAND_DK;

    /**
     * This field corresponds to DATEEDITOR_FONT_POPUPS skin property.
     * See its comment for further details.
     */
    public static Font FONT_POPUPS;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_BG skin property.
     * See its comment for further details.
     */
    public static Image[] IMAGE_BG;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_MON_BG skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_MONTH_BG;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_YR_BG skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_YEAR_BG;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_CAL_BG skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_CAL_BG;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_DATES skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_DATES;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_TIME_BG skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_TIME_BG;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_RADIO skin property.
     * See its comment for further details.
     */
    public static Image[] IMAGE_RADIO;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_AMPM skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_AMPM;

    /**
     * This field corresponds to DATEEDITOR_IMAGE_CLOCK_BG skin property.
     * See its comment for further details.
     */
    public static Image IMAGE_CLOCK_BG;
    
    // private constructor
    private DateEditorSkin() {
    }
    
}

    

