/*
 *
 * Copyright  1990-2006 Sun Microsystems, Inc. All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 only, as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details (a copy is
 * included at /legal/license.txt). 
 * 
 * You should have received a copy of the GNU General Public License
 * version 2 along with this work; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA 
 * 
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
 * Clara, CA 95054 or visit www.sun.com if you need additional
 * information or have any questions. 
 */

package com.sun.midp.chameleon.skins.resources;

import com.sun.midp.chameleon.skins.DateFieldSkin;
import com.sun.midp.chameleon.skins.SkinPropertiesIDs;

public class DateFieldResources {
	private static boolean init;

	// private constructor
	private DateFieldResources() {
	}

	public static void load() {
		load(false);
	}

	public static void load(boolean reload) {
		if (init && !reload) {
			return;
		}

		DateFieldSkin.PAD_H = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_PAD_H);
		DateFieldSkin.PAD_V = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_PAD_V);
		DateFieldSkin.BUTTON_BORDER_W = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_BTN_BRDR_W);
		DateFieldSkin.FONT = SkinResources.getFont(SkinPropertiesIDs.DATEFIELD_FONT);
		DateFieldSkin.COLOR_FG = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_FG);
		DateFieldSkin.COLOR_BG = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_BG);
		DateFieldSkin.COLOR_BORDER = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_BRDR);
		DateFieldSkin.COLOR_BORDER_LT = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_BRDR_LT);
		DateFieldSkin.COLOR_BORDER_DK = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_BRDR_DK);
		DateFieldSkin.COLOR_BORDER_SHD = SkinResources.getInt(SkinPropertiesIDs.DATEFIELD_COLOR_BRDR_SHD);

		if (SkinResources.isSkinImageEnabled()) {
			/*
			 Uncomment if background image is used
			 DateFieldSkin.IMAGE_BG = SkinResources.getCompositeImage(
			 SkinPropertiesIDs.DATEFIELD_IMAGE_BG, 9);
			 */
			DateFieldSkin.IMAGE_BUTTON_BG = SkinResources
					.getCompositeImage(SkinPropertiesIDs.DATEFIELD_IMAGE_BTN_BG, 9);
			DateFieldSkin.IMAGE_ICON_DATE = SkinResources.getImage(SkinPropertiesIDs.DATEFIELD_IMAGE_ICON_DATE);
			DateFieldSkin.IMAGE_ICON_TIME = SkinResources.getImage(SkinPropertiesIDs.DATEFIELD_IMAGE_ICON_TIME);
			DateFieldSkin.IMAGE_ICON_DATETIME = SkinResources.getImage(SkinPropertiesIDs.DATEFIELD_IMAGE_ICON_DATETIME);
		}

		init = true;
	}
}
