/**
 * Copyright  1990-2006 Sun Microsystems, Inc. All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 only, as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details (a copy is
 * included at /legal/license.txt). 
 * 
 * You should have received a copy of the GNU General Public License
 * version 2 along with this work; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA 
 * 
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
 * Clara, CA 95054 or visit www.sun.com if you need additional
 * information or have any questions. 
 * 
 * NOTE: DO NOT EDIT. THIS FILE IS GENERATED. If you want to 
 * edit it, you need to modify the corresponding XML files.
 */

package com.sun.midp.chameleon.skins.resources;
import javax.microedition.lcdui.Graphics;

public final class RomizedSkin {

    /**
     * A value of 'true' indicates this class can be relied upon to
     * provide romized values for all Chameleon skin properties. A value
     * of 'false' indicates the runtime should get the properties out
     * of the skin file on the filesystem.
     */
    public final static boolean ENABLED = true;

    // private constructor
    private RomizedSkin() {
    }

    private static final int[] properties = {
        // SCREEN_TEXT_ORIENT
        Graphics.RIGHT,
        // SCREEN_PAD_FORM_ITEMS
        4,
        // SCREEN_PAD_LABEL_VERT
        2,
        // SCREEN_PAD_LABEL_HORIZ
        3,
        // SCREEN_COLOR_BG
        0xFFFFFF,
        // SCREEN_COLOR_HS_BG
        0xFFFFFF,
        // SCREEN_COLOR_FG
        0x000000,
        // SCREEN_COLOR_BG_HL
        0xFFCC33,
        // SCREEN_COLOR_FG_HL
        0x000000,
        // SCREEN_COLOR_BORDER
        0x000000,
        // SCREEN_COLOR_BORDER_HL
        0xFFCC33,
        // SCREEN_COLOR_TRAVERSE_IND
        0xFFCC33,
        // SCREEN_BORDER_STYLE
        Graphics.SOLID,
        // SCREEN_FONT_LABEL
        0,
        // SCREEN_FONT_INPUT_TEXT
        0,
        // SCREEN_FONT_STATIC_TEXT
        0,
        // SCREEN_IMAGE_WASH
        0,
        // SCREEN_IMAGE_BG
        1,
        // SCREEN_IMAGE_BG_W_TITLE
        43,
        // SCREEN_IMAGE_BG_WO_TITLE
        43,
        // SCREEN_IMAGE_HS_BG_TILE
        2,
        // SCREEN_IMAGE_HS_BG_W_TITLE
        43,
        // SCREEN_IMAGE_HS_BG_WO_TITLE
        43,
        // SCROLL_MODE
        0,
        // SCROLL_WIDTH
        9,
        // SCROLL_COLOR_BG
        0x000000,
        // SCROLL_COLOR_FG
        0xFFFFFF,
        // SCROLL_IMAGE_BG
        52,
        // SCROLL_IMAGE_FG
        52,
        // SCROLL_IMAGE_UP
        3,
        // SCROLL_IMAGE_DN
        4,
        // SCROLL_COLOR_AU_BG
        0x000000,
        // SCROLL_COLOR_AU_FG
        0xFFFFFF,
        // SCROLL_IMAGE_AU_BG
        52,
        // SCROLL_IMAGE_AU_FG
        52,
        // SCROLL_IMAGE_AU_UP
        5,
        // SCROLL_IMAGE_AU_DN
        6,
        // SOFTBTN_HEIGHT
        18,
        // SOFTBTN_NUM_BUTTONS
        2,
        // SOFTBTN_BUTTON_SHD_ALIGN
        Graphics.BOTTOM | Graphics.RIGHT,
        // SOFTBTN_COLOR_FG
        0xFFFFFF,
        // SOFTBTN_COLOR_FG_SHD
        0x000000,
        // SOFTBTN_COLOR_BG
        0x264DB6,
        // SOFTBTN_COLOR_MU_FG
        0xFFFFFF,
        // SOFTBTN_COLOR_MU_FG_SHD
        0x000000,
        // SOFTBTN_COLOR_MU_BG
        0xFF9933,
        // SOFTBTN_COLOR_AU_FG
        0xFFFFFF,
        // SOFTBTN_COLOR_AU_FG_SHD
        0x000000,
        // SOFTBTN_COLOR_AU_BG
        0xF06409,
        // SOFTBTN_FONT
        1,
        // SOFTBTN_TEXT_MENUCMD
        0,
        // SOFTBTN_TEXT_BACKCMD
        1,
        // SOFTBTN_IMAGE_BG
        55,
        // SOFTBTN_IMAGE_MU_BG
        58,
        // SOFTBTN_IMAGE_AU_BG
        61,
        // TICKER_HEIGHT
        17,
        // TICKER_ALIGN
        Graphics.BOTTOM,
        // TICKER_DIRECTION
        Graphics.LEFT,
        // TICKER_RATE
        250,
        // TICKER_SPEED
        5,
        // TICKER_TEXT_ANCHOR_Y
        1,
        // TICKER_TEXT_SHD_ALIGN
        Graphics.BOTTOM | Graphics.RIGHT,
        // TICKER_COLOR_BG
        0x96DBDB,
        // TICKER_COLOR_FG
        0x000000,
        // TICKER_COLOR_FG_SHD
        0xCCCCFF,
        // TICKER_FONT
        2,
        // TICKER_IMAGE_BG
        64,
        // TICKER_IMAGE_AU_BG
        67,
        // PTI_HEIGHT
        17,
        // PTI_WIDTH
        168,
        // PTI_MARGIN
        3,
        // PTI_COLOR_BG
        0xA3E2F8,
        // PTI_COLOR_FG
        0x000000,
        // PTI_COLOR_FG_HL
        0x000000,
        // PTI_COLOR_BG_HL
        0xFFCC33,
        // PTI_COLOR_BDR
        0x336699,
        // PTI_FONT
        2,
        // PTI_IMAGE_BG
        70,
        // PTI_LEFT_ARROW
        7,
        // PTI_RIGHT_ARROW
        8,
        // TITLE_HEIGHT
        20,
        // TITLE_MARGIN
        5,
        // TITLE_TEXT_ALIGN_X
        Graphics.LEFT,
        // TITLE_TEXT_SHD_ALIGN
        Graphics.BOTTOM | Graphics.RIGHT,
        // TITLE_COLOR_FG
        0xFFFFFF,
        // TITLE_COLOR_FG_SHD
        0x000000,
        // TITLE_COLOR_BG
        0x1F3FB1,
        // TITLE_FONT
        1,
        // TITLE_IMAGE_BG
        73,
        // ALERT_WIDTH
        -1,
        // ALERT_HEIGHT
        125,
        // ALERT_ALIGN_X
        Graphics.HCENTER,
        // ALERT_ALIGN_Y
        Graphics.BOTTOM,
        // ALERT_MARGIN_H
        5,
        // ALERT_MARGIN_V
        0,
        // ALERT_TITLE_ALIGN
        Graphics.LEFT,
        // ALERT_TITLE_HEIGHT
        32,
        // ALERT_TITLE_MARGIN
        5,
        // ALERT_TEXT_TITLE_INFO
        2,
        // ALERT_TEXT_TITLE_WARN
        3,
        // ALERT_TEXT_TITLE_ERRR
        4,
        // ALERT_TEXT_TITLE_ALRM
        5,
        // ALERT_TEXT_TITLE_CNFM
        6,
        // ALERT_PAD_HORIZ
        0,
        // ALERT_PAD_VERT
        3,
        // ALERT_SCROLL_AMOUNT
        15,
        // ALERT_TIMEOUT
        2000,
        // ALERT_COLOR_BG
        0xFFCC33,
        // ALERT_COLOR_TITLE
        0x000000,
        // ALERT_COLOR_FG
        0x000000,
        // ALERT_FONT_TITLE
        3,
        // ALERT_FONT_TEXT
        0,
        // ALERT_IMAGE_BG
        76,
        // ALERT_IMAGE_ICON_INFO
        9,
        // ALERT_IMAGE_ICON_WARN
        10,
        // ALERT_IMAGE_ICON_ERRR
        11,
        // ALERT_IMAGE_ICON_ALRM
        12,
        // ALERT_IMAGE_ICON_CNFM
        13,
        // BUSYCRSR_WIDTH
        40,
        // BUSYCRSR_HEIGHT
        40,
        // BUSYCRSR_NUM_FRAMES
        17,
        // BUSYCRSR_FRAME_X
        0,
        // BUSYCRSR_FRAME_Y
        0,
        // BUSYCRSR_FRAME_SEQU
        0,
        // BUSYCRSR_IMAGE_BG
        14,
        // BUSYCRSR_IMAGE_FRAME
        85,
        // CHOICE_WIDTH_IMAGE
        16,
        // CHOICE_HEIGHT_IMAGE
        16,
        // CHOICE_WIDTH_SCROLL
        15,
        // CHOICE_WIDTH_THUMB
        3,
        // CHOICE_HEIGHT_THUMB
        4,
        // CHOICE_PAD_H
        4,
        // CHOICE_PAD_V
        2,
        // CHOICE_COLOR_FG
        0x000000,
        // CHOICE_COLOR_BG
        0xCCFFFF,
        // CHOICE_COLOR_BRDR
        0x003366,
        // CHOICE_COLOR_BRDR_SHD
        0x8db0d9,
        // CHOICE_COLOR_SCROLL
        0x003366,
        // CHOICE_COLOR_THUMB
        0x003366,
        // CHOICE_FONT
        0,
        // CHOICE_FONT_FOCUS
        0,
        // CHOICE_IMAGE_RADIO
        102,
        // CHOICE_IMAGE_CHKBX
        104,
        // CHOICE_IMAGE_BG
        43,
        // CHOICE_IMAGE_BTN_BG
        106,
        // CHOICE_IMAGE_BTN_ICON
        15,
        // CHOICE_IMAGE_POPUP_BG
        115,
        // DATEEDITOR_HEIGHT
        110,
        // DATEEDITOR_HEIGHT_POPUPS
        73,
        // DATEEDITOR_WIDTH_D
        111,
        // DATEEDITOR_WIDTH_T
        99,
        // DATEEDITOR_WIDTH_DT
        167,
        // DATEEDITOR_COLOR_BG
        0xFFEDA0,
        // DATEEDITOR_COLOR_POPUPS_BG
        0xF4DDD7,
        // DATEEDITOR_COLOR_BRDR
        0x0D0D0A,
        // DATEEDITOR_COLOR_TRAV_IND
        0xFF7012,
        // DATEEDITOR_COLOR_CLK_LT
        0xFFFFFF,
        // DATEEDITOR_COLOR_CLK_DK
        0x9D7E4F,
        // DATEEDITOR_FONT_POPUPS
        4,
        // DATEEDITOR_IMAGE_BG
        43,
        // DATEEDITOR_IMAGE_MON_BG
        16,
        // DATEEDITOR_IMAGE_YR_BG
        17,
        // DATEEDITOR_IMAGE_CAL_BG
        18,
        // DATEEDITOR_IMAGE_DATES
        19,
        // DATEEDITOR_IMAGE_TIME_BG
        20,
        // DATEEDITOR_IMAGE_RADIO
        124,
        // DATEEDITOR_IMAGE_AMPM
        21,
        // DATEEDITOR_IMAGE_CLOCK_BG
        22,
        // DATEFIELD_PAD_H
        3,
        // DATEFIELD_PAD_V
        2,
        // DATEFIELD_BTN_BRDR_W
        3,
        // DATEFIELD_FONT
        0,
        // DATEFIELD_COLOR_FG
        0x000000,
        // DATEFIELD_COLOR_BG
        0xC9E8FF,
        // DATEFIELD_COLOR_BRDR
        0x0D3964,
        // DATEFIELD_COLOR_BRDR_LT
        0x8DB0D9,
        // DATEFIELD_COLOR_BRDR_DK
        0x003366,
        // DATEFIELD_COLOR_BRDR_SHD
        0x8db0d9,
        // DATEFIELD_IMAGE_BG
        43,
        // DATEFIELD_IMAGE_BTN_BG
        126,
        // DATEFIELD_IMAGE_ICON_DATE
        23,
        // DATEFIELD_IMAGE_ICON_TIME
        24,
        // DATEFIELD_IMAGE_ICON_DATETIME
        25,
        // GAUGE_ORIENT
        8,
        // GAUGE_WIDTH
        137,
        // GAUGE_HEIGHT
        27,
        // GAUGE_METER_X
        24,
        // GAUGE_METER_Y
        0,
        // GAUGE_INC_BTN_X
        114,
        // GAUGE_INC_BTN_Y
        0,
        // GAUGE_DEC_BTN_X
        0,
        // GAUGE_DEC_BTN_Y
        0,
        // GAUGE_VALUE_X
        88,
        // GAUGE_VALUE_Y
        6,
        // GAUGE_VALUE_WIDTH
        24,
        // GAUGE_IMAGE_BG
        26,
        // GAUGE_IMAGE_MTR_EMPTY
        27,
        // GAUGE_IMAGE_MTR_FULL
        28,
        // GAUGE_IMAGE_INC_BTN
        29,
        // GAUGE_IMAGE_DEC_BTN
        30,
        // GAUGE_IMAGE_VALUES
        31,
        // IMAGEITEM_COLOR_BG_LNK_FOC
        0xFFCC33,
        // IMAGEITEM_COLOR_BG_BTN
        0xff0000,
        // IMAGEITEM_COLOR_BORDER_LT
        0x606060,
        // IMAGEITEM_COLOR_BORDER_DK
        0xAFAFAF,
        // IMAGEITEM_PAD_LNK_H
        3,
        // IMAGEITEM_PAD_LNK_V
        3,
        // IMAGEITEM_PAD_BTN_H
        4,
        // IMAGEITEM_PAD_BTN_V
        4,
        // IMAGEITEM_BTN_BORDER_W
        3,
        // IMAGEITEM_IMAGE_LNK_H
        32,
        // IMAGEITEM_IMAGE_LNK_V
        33,
        // IMAGEITEM_IMAGE_BUTTON
        135,
        // MENU_WIDTH
        144,
        // MENU_HEIGHT
        159,
        // MENU_ALIGN_X
        Graphics.RIGHT,
        // MENU_ALIGN_Y
        Graphics.BOTTOM,
        // MENU_TITLE_X
        80,
        // MENU_TITLE_Y
        2,
        // MENU_TITLE_MAXWIDTH
        100,
        // MENU_TITLE_ALIGN
        Graphics.HCENTER,
        // MENU_MAX_ITEMS
        9,
        // MENU_ITEM_HEIGHT
        15,
        // MENU_ITEM_TOPOFFSET
        21,
        // MENU_ITEM_INDEX_ANCHOR_X
        8,
        // MENU_ITEM_ANCHOR_X
        18,
        // MENU_COLOR_BG
        0xFFEAA1,
        // MENU_COLOR_BG_SEL
        0xFFCC33,
        // MENU_COLOR_TITLE
        0x000000,
        // MENU_COLOR_INDEX
        0x000000,
        // MENU_COLOR_INDEX_SEL
        0x000000,
        // MENU_COLOR_ITEM
        0x000000,
        // MENU_COLOR_ITEM_SEL
        0x000000,
        // MENU_TEXT_TITLE
        0,
        // MENU_FONT_TITLE
        2,
        // MENU_FONT_ITEM
        5,
        // MENU_FONT_ITEM_SEL
        1,
        // MENU_IMAGE_BG
        144,
        // MENU_IMAGE_ITEM_SEL_BG
        52,
        // MENU_IMAGE_SUBMENU
        34,
        // MENU_IMAGE_SUBMENU_HL
        35,
        // PBAR_ORIENT
        8,
        // PBAR_WIDTH
        168,
        // PBAR_HEIGHT
        22,
        // PBAR_METER_X
        36,
        // PBAR_METER_Y
        0,
        // PBAR_VALUE_X
        4,
        // PBAR_VALUE_Y
        3,
        // PBAR_VALUE_WIDTH
        32,
        // PBAR_IMAGE_BG
        36,
        // PBAR_IMAGE_MTR_EMPTY
        37,
        // PBAR_IMAGE_MTR_FULL
        38,
        // PBAR_IMAGE_VALUES
        39,
        // PBAR_IMAGE_PERCENTS
        40,
        // STRINGITEM_PAD_BUTTON_H
        6,
        // STRINGITEM_PAD_BUTTON_V
        1,
        // STRINGITEM_BUTTON_BORDER_W
        3,
        // STRINGITEM_COLOR_FG_LNK
        0x003399,
        // STRINGITEM_COLOR_FG_LNK_FOC
        0x003399,
        // STRINGITEM_COLOR_BG_LNK_FOC
        0xFFCC33,
        // STRINGITEM_COLOR_FG_BTN
        0x000000,
        // STRINGITEM_COLOR_BG_BTN
        0x7199E1,
        // STRINGITEM_COLOR_BORDER_LT
        0x606060,
        // STRINGITEM_COLOR_BORDER_DK
        0xAFAFAF,
        // STRINGITEM_FONT
        0,
        // STRINGITEM_FONT_LNK
        0,
        // STRINGITEM_FONT_BTN
        0,
        // STRINGITEM_IMAGE_LNK
        41,
        // STRINGITEM_IMAGE_BTN
        153,
        // TEXTFIELD_PAD_H
        3,
        // TEXTFIELD_PAD_V
        2,
        // TEXTFIELD_BOX_MARGIN
        4,
        // TEXTFIELD_WIDTH_CARET
        1,
        // TEXTFIELD_SCRL_RATE
        250,
        // TEXTFIELD_SCRL_SPD
        5,
        // TEXTFIELD_COLOR_FG
        0x000000,
        // TEXTFIELD_COLOR_BG
        0xFFFFFF,
        // TEXTFIELD_COLOR_BRDR
        0x000000,
        // TEXTFIELD_COLOR_BRDR_SHD
        0x8db0d9,
        // TEXTFIELD_COLOR_FG_UE
        0x5d5d5d,
        // TEXTFIELD_COLOR_BG_UE
        0xc2c2c2,
        // TEXTFIELD_COLOR_BRDR_UE
        0x000000,
        // TEXTFIELD_COLOR_BRDR_SHD_UE
        0xc2c2c2,
        // TEXTFIELD_IMAGE_BG
        43,
        // TEXTFIELD_IMAGE_BG_UE
        43,
        // UPDATEBAR_WIDTH
        150,
        // UPDATEBAR_HEIGHT
        25,
        // UPDATEBAR_NUM_FRAMES
        7,
        // UPDATEBAR_FRAME_X
        0,
        // UPDATEBAR_FRAME_Y
        0,
        // UPDATEBAR_FRAME_SEQU
        31,
        // UPDATEBAR_IMAGE_BG
        42,
        // UPDATEBAR_IMAGE_FRAME
        162,
        // SOFTBTN_BUTTON_ALIGN_X
        42,
        // SOFTBTN_BUTTON_MAX_WIDTH
        45,
        // SOFTBTN_BUTTON_ANCHOR_X
        48,
        // SOFTBTN_BUTTON_ANCHOR_Y
        51,
    };

    private static final int[] intSeqValues = {
        30,
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        15,
        14,
        13,
        12,
        11,
        10,
        9,
        8,
        7,
        6,
        5,
        4,
        3,
        2,
        10,
        1,
        2,
        3,
        4,
        5,
        6,
        5,
        4,
        3,
        2,
        2,
        Graphics.LEFT,
        Graphics.RIGHT,
        2,
        85,
        85,
        2,
        5,
        -5,
        2,
        0,
        0,
    };

    private static final String[] stringValues = {
        "Menu",
        "Back",
        "Information",
        "Warning",
        "Error",
        "Alarm",
        "Confirm",
    };

    private static final int[] fontValues = {
        FontResources.PROP_P_M,
        FontResources.SYS_B_M,
        FontResources.SYS_B_S,
        FontResources.PROP_B_S,
        FontResources.PROP_P_S,
        FontResources.SYS_P_M,
    };

    private static final String[] imageValues = {
        "screen.image_wash",
        "screen.image_bg",
        "",
        "scroll.image_up",
        "scroll.image_dn",
        "scroll.image_au_up",
        "scroll.image_au_dn",
        "pti.left_arrow",
        "pti.right_arrow",
        "alert.image_icon_info",
        "alert.image_icon_warn",
        "alert.image_icon_errr",
        "alert.image_icon_alrm",
        "alert.image_icon_cnfm",
        "busycrsr.image_bg",
        "choice.image_btn_icon",
        "dateeditor.image_mon_bg",
        "dateeditor.image_yr_bg",
        "dateeditor.image_cal_bg",
        "dateeditor.image_dates",
        "dateeditor.image_time_bg",
        "dateeditor.image_ampm",
        "dateeditor.image_clock_bg",
        "datefield.image_icon_date",
        "datefield.image_icon_time",
        "datefield.image_icon_datetime",
        "gauge.image_bg",
        "gauge.image_mtr_empty",
        "gauge.image_mtr_full",
        "gauge.image_inc_btn",
        "gauge.image_dec_btn",
        "gauge.image_values",
        "imageitem.image_lnk_h",
        "imageitem.image_lnk_v",
        "menu.image_submenu",
        "menu.image_submenu_hl",
        "pbar.image_bg",
        "pbar.image_mtr_empty",
        "pbar.image_mtr_full",
        "pbar.image_values",
        "pbar.image_prcnts",
        "stringitem.image_lnk",
        "updatebar.image_bg",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "softbtn.image_bg0",
        "softbtn.image_bg1",
        "softbtn.image_bg2",
        "softbtn.image_mu_bg0",
        "softbtn.image_mu_bg1",
        "softbtn.image_mu_bg2",
        "softbtn.image_au_bg0",
        "softbtn.image_au_bg1",
        "softbtn.image_au_bg2",
        "ticker.image_bg0",
        "ticker.image_bg1",
        "ticker.image_bg2",
        "ticker.image_au_bg0",
        "ticker.image_au_bg1",
        "ticker.image_au_bg2",
        "pti.image_bg0",
        "pti.image_bg1",
        "pti.image_bg2",
        "title.image_bg0",
        "title.image_bg1",
        "title.image_bg2",
        "alert.image_bg0",
        "alert.image_bg1",
        "alert.image_bg2",
        "alert.image_bg3",
        "alert.image_bg4",
        "alert.image_bg5",
        "alert.image_bg6",
        "alert.image_bg7",
        "alert.image_bg8",
        "busycrsr.image_frame0",
        "busycrsr.image_frame1",
        "busycrsr.image_frame2",
        "busycrsr.image_frame3",
        "busycrsr.image_frame4",
        "busycrsr.image_frame5",
        "busycrsr.image_frame6",
        "busycrsr.image_frame7",
        "busycrsr.image_frame8",
        "busycrsr.image_frame9",
        "busycrsr.image_frame10",
        "busycrsr.image_frame11",
        "busycrsr.image_frame12",
        "busycrsr.image_frame13",
        "busycrsr.image_frame14",
        "busycrsr.image_frame15",
        "busycrsr.image_frame16",
        "choice.image_radio0",
        "choice.image_radio1",
        "choice.image_chkbx0",
        "choice.image_chkbx1",
        "choice.image_btn_bg0",
        "choice.image_btn_bg1",
        "choice.image_btn_bg2",
        "choice.image_btn_bg3",
        "choice.image_btn_bg4",
        "choice.image_btn_bg5",
        "choice.image_btn_bg6",
        "choice.image_btn_bg7",
        "choice.image_btn_bg8",
        "choice.image_popup_bg0",
        "choice.image_popup_bg1",
        "choice.image_popup_bg2",
        "choice.image_popup_bg3",
        "choice.image_popup_bg4",
        "choice.image_popup_bg5",
        "choice.image_popup_bg6",
        "choice.image_popup_bg7",
        "choice.image_popup_bg8",
        "dateeditor.image_radio0",
        "dateeditor.image_radio1",
        "datefield.image_btn_bg0",
        "datefield.image_btn_bg1",
        "datefield.image_btn_bg2",
        "datefield.image_btn_bg3",
        "datefield.image_btn_bg4",
        "datefield.image_btn_bg5",
        "datefield.image_btn_bg6",
        "datefield.image_btn_bg7",
        "datefield.image_btn_bg8",
        "imageitem.image_btn0",
        "imageitem.image_btn1",
        "imageitem.image_btn2",
        "imageitem.image_btn3",
        "imageitem.image_btn4",
        "imageitem.image_btn5",
        "imageitem.image_btn6",
        "imageitem.image_btn7",
        "imageitem.image_btn8",
        "menu.image_bg0",
        "menu.image_bg1",
        "menu.image_bg2",
        "menu.image_bg3",
        "menu.image_bg4",
        "menu.image_bg5",
        "menu.image_bg6",
        "menu.image_bg7",
        "menu.image_bg8",
        "stringitem.image_btn0",
        "stringitem.image_btn1",
        "stringitem.image_btn2",
        "stringitem.image_btn3",
        "stringitem.image_btn4",
        "stringitem.image_btn5",
        "stringitem.image_btn6",
        "stringitem.image_btn7",
        "stringitem.image_btn8",
        "updatebar.image_frame0",
        "updatebar.image_frame1",
        "updatebar.image_frame2",
        "updatebar.image_frame3",
        "updatebar.image_frame4",
        "updatebar.image_frame5",
        "updatebar.image_frame6",
    };

    private static final int[] romizedImagesIndexes = {
        0,
        -1,
        -1,
        1,
        2,
        3,
        4,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        5,
        6,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        7,
        8,
        9,
        10,
        11,
        12,
        13,
        14,
        15,
        16,
        17,
        18,
        -1,
        -1,
        -1,
        19,
        20,
        21,
        22,
        23,
        24,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        25,
        26,
        27,
        28,
        29,
        30,
        31,
        32,
        33,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
        -1,
    };

    public static void getProperties(LoadedSkinProperties props) {
        if (props == null) {
            return;
        }

        props.properties = properties;
        props.stringValues = stringValues;
        props.fontValues = fontValues;
        props.imageValues = imageValues;
        props.intSeqValues = intSeqValues;
    }

    public static int getRomizedImageIndex(int imageIndex) {
        return romizedImagesIndexes[imageIndex];
    }
}
