package gnu.x11.extension.glx;


/** GL constant. */
public interface GLConstant {
  public static final int CURRENT_BIT = 1<<0;
  public static final int POINT_BIT = 1<<1;
  public static final int LINE_BIT = 1<<2;
  public static final int POLYGON_BIT = 1<<3;
  public static final int POLYGON_STIPPLE_BIT = 1<<4;
  public static final int PIXEL_MODE_BIT = 1<<5;
  public static final int LIGHTING_BIT = 1<<6;
  public static final int FOG_BIT = 1<<7;
  public static final int DEPTH_BUFFER_BIT = 1<<8;
  public static final int ACCUM_BUFFER_BIT = 1<<9;
  public static final int STENCIL_BUFFER_BIT = 1<<10;
  public static final int VIEWPORT_BIT = 1<<11;
  public static final int TRANSFORM_BIT = 1<<12;
  public static final int ENABLE_BIT = 1<<13;
  public static final int COLOR_BUFFER_BIT = 1<<14;
  public static final int HINT_BIT = 1<<15;
  public static final int EVAL_BIT = 1<<16;
  public static final int LIST_BIT = 1<<17;
  public static final int TEXTURE_BIT = 1<<18;
  public static final int SCISSOR_BIT = 1<<19;
  public static final int ALL_ATTRIB_BITS = 0x000fffff;

  public static final int CLIENT_PIXEL_STORE_BIT = 1<<0;
  public static final int CLIENT_VERTEX_ARRAY_BIT = 1<<1;
  public static final int CLIENT_ALL_ATTRIB_BITS = 0xffffffff;

  public static final int FALSE = 0;
  public static final int NO_ERROR = 0;
  public static final int NONE = 0;
  public static final int ZERO = 0;
  public static final int ONE = 1;
  public static final int TRUE = 1;
  public static final int ACCUM = 0x0100;
  public static final int LOAD = 0x0101;
  public static final int RETURN = 0x0102;
  public static final int MULT = 0x0103;
  public static final int ADD = 0x0104;
  public static final int NEVER = 0x0200;
  public static final int LESS = 0x0201;
  public static final int EQUAL = 0x0202;
  public static final int LEQUAL = 0x0203;
  public static final int GREATER = 0x0204;
  public static final int NOTEQUAL = 0x0205;
  public static final int GEQUAL = 0x0206;
  public static final int ALWAYS = 0x0207;
  public static final int POINTS = 0x0000;
  public static final int LINES = 0x0001;
  public static final int LINE_LOOP = 0x0002;
  public static final int LINE_STRIP = 0x0003;
  public static final int TRIANGLES = 0x0004;
  public static final int TRIANGLE_STRIP = 0x0005;
  public static final int TRIANGLE_FAN = 0x0006;
  public static final int QUADS = 0x0007;
  public static final int QUAD_STRIP = 0x0008;
  public static final int POLYGON = 0x0009;
  public static final int SRC_COLOR = 0x0300;
  public static final int ONE_MINUS_SRC_COLOR = 0x0301;
  public static final int SRC_ALPHA = 0x0302;
  public static final int ONE_MINUS_SRC_ALPHA = 0x0303;
  public static final int DST_ALPHA = 0x0304;
  public static final int ONE_MINUS_DST_ALPHA = 0x0305;
  public static final int DST_COLOR = 0x0306;
  public static final int ONE_MINUS_DST_COLOR = 0x0307;
  public static final int SRC_ALPHA_SATURATE = 0x0308;
  public static final int CLIP_PLANE0 = 0x3000;
  public static final int CLIP_PLANE1 = 0x3001;
  public static final int CLIP_PLANE2 = 0x3002;
  public static final int CLIP_PLANE3 = 0x3003;
  public static final int CLIP_PLANE4 = 0x3004;
  public static final int CLIP_PLANE5 = 0x3005;
  public static final int BYTE = 0x1400;
  public static final int UNSIGNED_BYTE = 0x1401;
  public static final int SHORT = 0x1402;
  public static final int UNSIGNED_SHORT = 0x1403;
  public static final int INT = 0x1404;
  public static final int UNSIGNED_INT = 0x1405;
  public static final int FLOAT = 0x1406;
  public static final int X2_BYTES = 0x1407;
  public static final int X3_BYTES = 0x1408;
  public static final int X4_BYTES = 0x1409;
  public static final int DOUBLE = 0x140a;
  public static final int FRONT_LEFT = 0x0400;
  public static final int FRONT_RIGHT = 0x0401;
  public static final int BACK_LEFT = 0x0402;
  public static final int BACK_RIGHT = 0x0403;
  public static final int FRONT = 0x0404;
  public static final int BACK = 0x0405;
  public static final int LEFT = 0x0406;
  public static final int RIGHT = 0x0407;
  public static final int FRONT_AND_BACK = 0x0408;
  public static final int AUX0 = 0x0409;
  public static final int AUX1 = 0x040a;
  public static final int AUX2 = 0x040b;
  public static final int AUX3 = 0x040c;
  public static final int INVALID_ENUM = 0x0500;
  public static final int INVALID_VALUE = 0x0501;
  public static final int INVALID_OPERATION = 0x0502;
  public static final int STACK_OVERFLOW = 0x0503;
  public static final int STACK_UNDERFLOW = 0x0504;
  public static final int OUT_OF_MEMORY = 0x0505;
  public static final int X2D = 0x0600;
  public static final int X3D = 0x0601;
  public static final int X3D_COLOR = 0x0602;
  public static final int X3D_COLOR_TEXTURE = 0x0603;
  public static final int X4D_COLOR_TEXTURE = 0x0604;
  public static final int PASS_THROUGH_TOKEN = 0x0700;
  public static final int POINT_TOKEN = 0x0701;
  public static final int LINE_TOKEN = 0x0702;
  public static final int POLYGON_TOKEN = 0x0703;
  public static final int BITMAP_TOKEN = 0x0704;
  public static final int DRAW_PIXEL_TOKEN = 0x0705;
  public static final int COPY_PIXEL_TOKEN = 0x0706;
  public static final int LINE_RESET_TOKEN = 0x0707;
  public static final int EXP = 0x0800;
  public static final int EXP2 = 0x0801;
  public static final int CW = 0x0900;
  public static final int CCW = 0x0901;
  public static final int COEFF = 0x0a00;
  public static final int ORDER = 0x0a01;
  public static final int DOMAIN = 0x0a02;
  public static final int CURRENT_COLOR = 0x0b00;
  public static final int CURRENT_INDEX = 0x0b01;
  public static final int CURRENT_NORMAL = 0x0b02;
  public static final int CURRENT_TEXTURE_COORDS = 0x0b03;
  public static final int CURRENT_RASTER_COLOR = 0x0b04;
  public static final int CURRENT_RASTER_INDEX = 0x0b05;
  public static final int CURRENT_RASTER_TEXTURE_COORDS = 0x0b06;
  public static final int CURRENT_RASTER_POSITION = 0x0b07;
  public static final int CURRENT_RASTER_POSITION_VALID = 0x0b08;
  public static final int CURRENT_RASTER_DISTANCE = 0x0b09;
  public static final int POINT_SMOOTH = 0x0b10;
  public static final int POINT_SIZE = 0x0b11;
  public static final int POINT_SIZE_RANGE = 0x0b12;
  public static final int POINT_SIZE_GRANULARITY = 0x0b13;
  public static final int LINE_SMOOTH = 0x0b20;
  public static final int LINE_WIDTH = 0x0b21;
  public static final int LINE_WIDTH_RANGE = 0x0b22;
  public static final int LINE_WIDTH_GRANULARITY = 0x0b23;
  public static final int LINE_STIPPLE = 0x0b24;
  public static final int LINE_STIPPLE_PATTERN = 0x0b25;
  public static final int LINE_STIPPLE_REPEAT = 0x0b26;
  public static final int LIST_MODE = 0x0b30;
  public static final int MAX_LIST_NESTING = 0x0b31;
  public static final int LIST_BASE = 0x0b32;
  public static final int LIST_INDEX = 0x0b33;
  public static final int POLYGON_MODE = 0x0b40;
  public static final int POLYGON_SMOOTH = 0x0b41;
  public static final int POLYGON_STIPPLE = 0x0b42;
  public static final int EDGE_FLAG = 0x0b43;
  public static final int CULL_FACE = 0x0b44;
  public static final int CULL_FACE_MODE = 0x0b45;
  public static final int FRONT_FACE = 0x0b46;
  public static final int LIGHTING = 0x0b50;
  public static final int LIGHT_MODEL_LOCAL_VIEWER = 0x0b51;
  public static final int LIGHT_MODEL_TWO_SIDE = 0x0b52;
  public static final int LIGHT_MODEL_AMBIENT = 0x0b53;
  public static final int SHADE_MODEL = 0x0b54;
  public static final int COLOR_MATERIAL_FACE = 0x0b55;
  public static final int COLOR_MATERIAL_PARAMETER = 0x0b56;
  public static final int COLOR_MATERIAL = 0x0b57;
  public static final int FOG = 0x0b60;
  public static final int FOG_INDEX = 0x0b61;
  public static final int FOG_DENSITY = 0x0b62;
  public static final int FOG_START = 0x0b63;
  public static final int FOG_END = 0x0b64;
  public static final int FOG_MODE = 0x0b65;
  public static final int FOG_COLOR = 0x0b66;
  public static final int DEPTH_RANGE = 0x0b70;
  public static final int DEPTH_TEST = 0x0b71;
  public static final int DEPTH_WRITEMASK = 0x0b72;
  public static final int DEPTH_CLEAR_VALUE = 0x0b73;
  public static final int DEPTH_FUNC = 0x0b74;
  public static final int ACCUM_CLEAR_VALUE = 0x0b80;
  public static final int STENCIL_TEST = 0x0b90;
  public static final int STENCIL_CLEAR_VALUE = 0x0b91;
  public static final int STENCIL_FUNC = 0x0b92;
  public static final int STENCIL_VALUE_MASK = 0x0b93;
  public static final int STENCIL_FAIL = 0x0b94;
  public static final int STENCIL_PASS_DEPTH_FAIL = 0x0b95;
  public static final int STENCIL_PASS_DEPTH_PASS = 0x0b96;
  public static final int STENCIL_REF = 0x0b97;
  public static final int STENCIL_WRITEMASK = 0x0b98;
  public static final int MATRIX_MODE = 0x0ba0;
  public static final int NORMALIZE = 0x0ba1;
  public static final int VIEWPORT = 0x0ba2;
  public static final int MODELVIEW_STACK_DEPTH = 0x0ba3;
  public static final int PROJECTION_STACK_DEPTH = 0x0ba4;
  public static final int TEXTURE_STACK_DEPTH = 0x0ba5;
  public static final int MODELVIEW_MATRIX = 0x0ba6;
  public static final int PROJECTION_MATRIX = 0x0ba7;
  public static final int TEXTURE_MATRIX = 0x0ba8;
  public static final int ATTRIB_STACK_DEPTH = 0x0bb0;
  public static final int CLIENT_ATTRIB_STACK_DEPTH = 0x0bb1;
  public static final int ALPHA_TEST = 0x0bc0;
  public static final int ALPHA_TEST_FUNC = 0x0bc1;
  public static final int ALPHA_TEST_REF = 0x0bc2;
  public static final int DITHER = 0x0bd0;
  public static final int BLEND_DST = 0x0be0;
  public static final int BLEND_SRC = 0x0be1;
  public static final int BLEND = 0x0be2;
  public static final int LOGIC_OP_MODE = 0x0bf0;
  public static final int LOGIC_OP = 0x0bf1;
  public static final int INDEX_LOGIC_OP = 0x0bf1;
  public static final int COLOR_LOGIC_OP = 0x0bf2;
  public static final int AUX_BUFFERS = 0x0c00;
  public static final int DRAW_BUFFER = 0x0c01;
  public static final int READ_BUFFER = 0x0c02;
  public static final int SCISSOR_BOX = 0x0c10;
  public static final int SCISSOR_TEST = 0x0c11;
  public static final int INDEX_CLEAR_VALUE = 0x0c20;
  public static final int INDEX_WRITEMASK = 0x0c21;
  public static final int COLOR_CLEAR_VALUE = 0x0c22;
  public static final int COLOR_WRITEMASK = 0x0c23;
  public static final int INDEX_MODE = 0x0c30;
  public static final int RGBA_MODE = 0x0c31;
  public static final int DOUBLEBUFFER = 0x0c32;
  public static final int STEREO = 0x0c33;
  public static final int RENDER_MODE = 0x0c40;
  public static final int PERSPECTIVE_CORRECTION_HINT = 0x0c50;
  public static final int POINT_SMOOTH_HINT = 0x0c51;
  public static final int LINE_SMOOTH_HINT = 0x0c52;
  public static final int POLYGON_SMOOTH_HINT = 0x0c53;
  public static final int FOG_HINT = 0x0c54;
  public static final int TEXTURE_GEN_S = 0x0c60;
  public static final int TEXTURE_GEN_T = 0x0c61;
  public static final int TEXTURE_GEN_R = 0x0c62;
  public static final int TEXTURE_GEN_Q = 0x0c63;
  public static final int PIXEL_MAP_I_TO_I = 0x0c70;
  public static final int PIXEL_MAP_S_TO_S = 0x0c71;
  public static final int PIXEL_MAP_I_TO_R = 0x0c72;
  public static final int PIXEL_MAP_I_TO_G = 0x0c73;
  public static final int PIXEL_MAP_I_TO_B = 0x0c74;
  public static final int PIXEL_MAP_I_TO_A = 0x0c75;
  public static final int PIXEL_MAP_R_TO_R = 0x0c76;
  public static final int PIXEL_MAP_G_TO_G = 0x0c77;
  public static final int PIXEL_MAP_B_TO_B = 0x0c78;
  public static final int PIXEL_MAP_A_TO_A = 0x0c79;
  public static final int PIXEL_MAP_I_TO_I_SIZE = 0x0cb0;
  public static final int PIXEL_MAP_S_TO_S_SIZE = 0x0cb1;
  public static final int PIXEL_MAP_I_TO_R_SIZE = 0x0cb2;
  public static final int PIXEL_MAP_I_TO_G_SIZE = 0x0cb3;
  public static final int PIXEL_MAP_I_TO_B_SIZE = 0x0cb4;
  public static final int PIXEL_MAP_I_TO_A_SIZE = 0x0cb5;
  public static final int PIXEL_MAP_R_TO_R_SIZE = 0x0cb6;
  public static final int PIXEL_MAP_G_TO_G_SIZE = 0x0cb7;
  public static final int PIXEL_MAP_B_TO_B_SIZE = 0x0cb8;
  public static final int PIXEL_MAP_A_TO_A_SIZE = 0x0cb9;
  public static final int UNPACK_SWAP_BYTES = 0x0cf0;
  public static final int UNPACK_LSB_FIRST = 0x0cf1;
  public static final int UNPACK_ROW_LENGTH = 0x0cf2;
  public static final int UNPACK_SKIP_ROWS = 0x0cf3;
  public static final int UNPACK_SKIP_PIXELS = 0x0cf4;
  public static final int UNPACK_ALIGNMENT = 0x0cf5;
  public static final int PACK_SWAP_BYTES = 0x0d00;
  public static final int PACK_LSB_FIRST = 0x0d01;
  public static final int PACK_ROW_LENGTH = 0x0d02;
  public static final int PACK_SKIP_ROWS = 0x0d03;
  public static final int PACK_SKIP_PIXELS = 0x0d04;
  public static final int PACK_ALIGNMENT = 0x0d05;
  public static final int MAP_COLOR = 0x0d10;
  public static final int MAP_STENCIL = 0x0d11;
  public static final int INDEX_SHIFT = 0x0d12;
  public static final int INDEX_OFFSET = 0x0d13;
  public static final int RED_SCALE = 0x0d14;
  public static final int RED_BIAS = 0x0d15;
  public static final int ZOOM_X = 0x0d16;
  public static final int ZOOM_Y = 0x0d17;
  public static final int GREEN_SCALE = 0x0d18;
  public static final int GREEN_BIAS = 0x0d19;
  public static final int BLUE_SCALE = 0x0d1a;
  public static final int BLUE_BIAS = 0x0d1b;
  public static final int ALPHA_SCALE = 0x0d1c;
  public static final int ALPHA_BIAS = 0x0d1d;
  public static final int DEPTH_SCALE = 0x0d1e;
  public static final int DEPTH_BIAS = 0x0d1f;
  public static final int MAX_EVAL_ORDER = 0x0d30;
  public static final int MAX_LIGHTS = 0x0d31;
  public static final int MAX_CLIP_PLANES = 0x0d32;
  public static final int MAX_TEXTURE_SIZE = 0x0d33;
  public static final int MAX_PIXEL_MAP_TABLE = 0x0d34;
  public static final int MAX_ATTRIB_STACK_DEPTH = 0x0d35;
  public static final int MAX_MODELVIEW_STACK_DEPTH = 0x0d36;
  public static final int MAX_NAME_STACK_DEPTH = 0x0d37;
  public static final int MAX_PROJECTION_STACK_DEPTH = 0x0d38;
  public static final int MAX_TEXTURE_STACK_DEPTH = 0x0d39;
  public static final int MAX_VIEWPORT_DIMS = 0x0d3a;
  public static final int MAX_CLIENT_ATTRIB_STACK_DEPTH = 0x0d3b;
  public static final int SUBPIXEL_BITS = 0x0d50;
  public static final int INDEX_BITS = 0x0d51;
  public static final int RED_BITS = 0x0d52;
  public static final int GREEN_BITS = 0x0d53;
  public static final int BLUE_BITS = 0x0d54;
  public static final int ALPHA_BITS = 0x0d55;
  public static final int DEPTH_BITS = 0x0d56;
  public static final int STENCIL_BITS = 0x0d57;
  public static final int ACCUM_RED_BITS = 0x0d58;
  public static final int ACCUM_GREEN_BITS = 0x0d59;
  public static final int ACCUM_BLUE_BITS = 0x0d5a;
  public static final int ACCUM_ALPHA_BITS = 0x0d5b;
  public static final int NAME_STACK_DEPTH = 0x0d70;
  public static final int AUTO_NORMAL = 0x0d80;
  public static final int MAP1_COLOR_4 = 0x0d90;
  public static final int MAP1_INDEX = 0x0d91;
  public static final int MAP1_NORMAL = 0x0d92;
  public static final int MAP1_TEXTURE_COORD_1 = 0x0d93;
  public static final int MAP1_TEXTURE_COORD_2 = 0x0d94;
  public static final int MAP1_TEXTURE_COORD_3 = 0x0d95;
  public static final int MAP1_TEXTURE_COORD_4 = 0x0d96;
  public static final int MAP1_VERTEX_3 = 0x0d97;
  public static final int MAP1_VERTEX_4 = 0x0d98;
  public static final int MAP2_COLOR_4 = 0x0db0;
  public static final int MAP2_INDEX = 0x0db1;
  public static final int MAP2_NORMAL = 0x0db2;
  public static final int MAP2_TEXTURE_COORD_1 = 0x0db3;
  public static final int MAP2_TEXTURE_COORD_2 = 0x0db4;
  public static final int MAP2_TEXTURE_COORD_3 = 0x0db5;
  public static final int MAP2_TEXTURE_COORD_4 = 0x0db6;
  public static final int MAP2_VERTEX_3 = 0x0db7;
  public static final int MAP2_VERTEX_4 = 0x0db8;
  public static final int MAP1_GRID_DOMAIN = 0x0dd0;
  public static final int MAP1_GRID_SEGMENTS = 0x0dd1;
  public static final int MAP2_GRID_DOMAIN = 0x0dd2;
  public static final int MAP2_GRID_SEGMENTS = 0x0dd3;
  public static final int TEXTURE_1D = 0x0de0;
  public static final int TEXTURE_2D = 0x0de1;
  public static final int FEEDBACK_BUFFER_POINTER = 0x0df0;
  public static final int FEEDBACK_BUFFER_SIZE = 0x0df1;
  public static final int FEEDBACK_BUFFER_TYPE = 0x0df2;
  public static final int SELECTION_BUFFER_POINTER = 0x0df3;
  public static final int SELECTION_BUFFER_SIZE = 0x0df4;
  public static final int TEXTURE_WIDTH = 0x1000;
  public static final int TEXTURE_HEIGHT = 0x1001;
  public static final int TEXTURE_INTERNAL_FORMAT = 0x1003;
  public static final int TEXTURE_BORDER_COLOR = 0x1004;
  public static final int TEXTURE_BORDER = 0x1005;
  public static final int DONT_CARE = 0x1100;
  public static final int FASTEST = 0x1101;
  public static final int NICEST = 0x1102;
  public static final int LIGHT0 = 0x4000;
  public static final int LIGHT1 = 0x4001;
  public static final int LIGHT2 = 0x4002;
  public static final int LIGHT3 = 0x4003;
  public static final int LIGHT4 = 0x4004;
  public static final int LIGHT5 = 0x4005;
  public static final int LIGHT6 = 0x4006;
  public static final int LIGHT7 = 0x4007;
  public static final int AMBIENT = 0x1200;
  public static final int DIFFUSE = 0x1201;
  public static final int SPECULAR = 0x1202;
  public static final int POSITION = 0x1203;
  public static final int SPOT_DIRECTION = 0x1204;
  public static final int SPOT_EXPONENT = 0x1205;
  public static final int SPOT_CUTOFF = 0x1206;
  public static final int CONSTANT_ATTENUATION = 0x1207;
  public static final int LINEAR_ATTENUATION = 0x1208;
  public static final int QUADRATIC_ATTENUATION = 0x1209;
  public static final int COMPILE = 0x1300;
  public static final int COMPILE_AND_EXECUTE = 0x1301;
  public static final int CLEAR = 0x1500;
  public static final int AND = 0x1501;
  public static final int AND_REVERSE = 0x1502;
  public static final int COPY = 0x1503;
  public static final int AND_INVERTED = 0x1504;
  public static final int NOOP = 0x1505;
  public static final int XOR = 0x1506;
  public static final int OR = 0x1507;
  public static final int NOR = 0x1508;
  public static final int EQUIV = 0x1509;
  public static final int INVERT = 0x150a;
  public static final int OR_REVERSE = 0x150b;
  public static final int COPY_INVERTED = 0x150c;
  public static final int OR_INVERTED = 0x150d;
  public static final int NAND = 0x150e;
  public static final int SET = 0x150f;
  public static final int EMISSION = 0x1600;
  public static final int SHININESS = 0x1601;
  public static final int AMBIENT_AND_DIFFUSE = 0x1602;
  public static final int COLOR_INDEXES = 0x1603;
  public static final int MODELVIEW = 0x1700;
  public static final int PROJECTION = 0x1701;
  public static final int TEXTURE = 0x1702;
  public static final int COLOR = 0x1800;
  public static final int DEPTH = 0x1801;
  public static final int STENCIL = 0x1802;
  public static final int COLOR_INDEX = 0x1900;
  public static final int STENCIL_INDEX = 0x1901;
  public static final int DEPTH_COMPONENT = 0x1902;
  public static final int RED = 0x1903;
  public static final int GREEN = 0x1904;
  public static final int BLUE = 0x1905;
  public static final int ALPHA = 0x1906;
  public static final int RGB = 0x1907;
  public static final int RGBA = 0x1908;
  public static final int LUMINANCE = 0x1909;
  public static final int LUMINANCE_ALPHA = 0x190a;
  public static final int BITMAP = 0x1a00;
  public static final int POINT = 0x1b00;
  public static final int LINE = 0x1b01;
  public static final int FILL = 0x1b02;
  public static final int RENDER = 0x1c00;
  public static final int FEEDBACK = 0x1c01;
  public static final int SELECT = 0x1c02;
  public static final int FLAT = 0x1d00;
  public static final int SMOOTH = 0x1d01;
  public static final int KEEP = 0x1e00;
  public static final int REPLACE = 0x1e01;
  public static final int INCR = 0x1e02;
  public static final int DECR = 0x1e03;
  public static final int VENDOR = 0x1f00;
  public static final int RENDERER = 0x1f01;
  public static final int VERSION = 0x1f02;
  public static final int EXTENSIONS = 0x1f03;
  public static final int S = 0x2000;
  public static final int T = 0x2001;
  public static final int R = 0x2002;
  public static final int Q = 0x2003;
  public static final int MODULATE = 0x2100;
  public static final int DECAL = 0x2101;
  public static final int TEXTURE_ENV_MODE = 0x2200;
  public static final int TEXTURE_ENV_COLOR = 0x2201;
  public static final int TEXTURE_ENV = 0x2300;
  public static final int EYE_LINEAR = 0x2400;
  public static final int OBJECT_LINEAR = 0x2401;
  public static final int SPHERE_MAP = 0x2402;
  public static final int TEXTURE_GEN_MODE = 0x2500;
  public static final int OBJECT_PLANE = 0x2501;
  public static final int EYE_PLANE = 0x2502;
  public static final int NEAREST = 0x2600;
  public static final int LINEAR = 0x2601;
  public static final int NEAREST_MIPMAP_NEAREST = 0x2700;
  public static final int LINEAR_MIPMAP_NEAREST = 0x2701;
  public static final int NEAREST_MIPMAP_LINEAR = 0x2702;
  public static final int LINEAR_MIPMAP_LINEAR = 0x2703;
  public static final int TEXTURE_MAG_FILTER = 0x2800;
  public static final int TEXTURE_MIN_FILTER = 0x2801;
  public static final int TEXTURE_WRAP_S = 0x2802;
  public static final int TEXTURE_WRAP_T = 0x2803;
  public static final int CLAMP = 0x2900;
  public static final int REPEAT = 0x2901;
  public static final int POLYGON_OFFSET_FACTOR = 0x8038;
  public static final int POLYGON_OFFSET_UNITS = 0x2a00;
  public static final int POLYGON_OFFSET_POINT = 0x2a01;
  public static final int POLYGON_OFFSET_LINE = 0x2a02;
  public static final int POLYGON_OFFSET_FILL = 0x8037;
  public static final int ALPHA4 = 0x803b;
  public static final int ALPHA8 = 0x803c;
  public static final int ALPHA12 = 0x803d;
  public static final int ALPHA16 = 0x803e;
  public static final int LUMINANCE4 = 0x803f;
  public static final int LUMINANCE8 = 0x8040;
  public static final int LUMINANCE12 = 0x8041;
  public static final int LUMINANCE16 = 0x8042;
  public static final int LUMINANCE4_ALPHA4 = 0x8043;
  public static final int LUMINANCE6_ALPHA2 = 0x8044;
  public static final int LUMINANCE8_ALPHA8 = 0x8045;
  public static final int LUMINANCE12_ALPHA4 = 0x8046;
  public static final int LUMINANCE12_ALPHA12 = 0x8047;
  public static final int LUMINANCE16_ALPHA16 = 0x8048;
  public static final int INTENSITY = 0x8049;
  public static final int INTENSITY4 = 0x804a;
  public static final int INTENSITY8 = 0x804b;
  public static final int INTENSITY12 = 0x804c;
  public static final int INTENSITY16 = 0x804d;
  public static final int R3_G3_B2 = 0x2a10;
  public static final int RGB4 = 0x804f;
  public static final int RGB5 = 0x8050;
  public static final int RGB8 = 0x8051;
  public static final int RGB10 = 0x8052;
  public static final int RGB12 = 0x8053;
  public static final int RGB16 = 0x8054;
  public static final int RGBA2 = 0x8055;
  public static final int RGBA4 = 0x8056;
  public static final int RGB5_A1 = 0x8057;
  public static final int RGBA8 = 0x8058;
  public static final int RGB10_A2 = 0x8059;
  public static final int RGBA12 = 0x805a;
  public static final int RGBA16 = 0x805b;
  public static final int TEXTURE_RED_SIZE = 0x805c;
  public static final int TEXTURE_GREEN_SIZE = 0x805d;
  public static final int TEXTURE_BLUE_SIZE = 0x805e;
  public static final int TEXTURE_ALPHA_SIZE = 0x805f;
  public static final int TEXTURE_LUMINANCE_SIZE = 0x8060;
  public static final int TEXTURE_INTENSITY_SIZE = 0x8061;
  public static final int PROXY_TEXTURE_1D = 0x8063;
  public static final int PROXY_TEXTURE_2D = 0x8064;
  public static final int TEXTURE_PRIORITY = 0x8066;
  public static final int TEXTURE_RESIDENT = 0x8067;
  public static final int TEXTURE_BINDING_1D = 0x8068;
  public static final int TEXTURE_BINDING_2D = 0x8069;
  public static final int VERTEX_ARRAY = 0x8074;
  public static final int NORMAL_ARRAY = 0x8075;
  public static final int COLOR_ARRAY = 0x8076;
  public static final int INDEX_ARRAY = 0x8077;
  public static final int TEXTURE_COORD_ARRAY = 0x8078;
  public static final int EDGE_FLAG_ARRAY = 0x8079;
  public static final int VERTEX_ARRAY_SIZE = 0x807a;
  public static final int VERTEX_ARRAY_TYPE = 0x807b;
  public static final int VERTEX_ARRAY_STRIDE = 0x807c;
  public static final int NORMAL_ARRAY_TYPE = 0x807e;
  public static final int NORMAL_ARRAY_STRIDE = 0x807f;
  public static final int COLOR_ARRAY_SIZE = 0x8081;
  public static final int COLOR_ARRAY_TYPE = 0x8082;
  public static final int COLOR_ARRAY_STRIDE = 0x8083;
  public static final int INDEX_ARRAY_TYPE = 0x8085;
  public static final int INDEX_ARRAY_STRIDE = 0x8086;
  public static final int TEXTURE_COORD_ARRAY_SIZE = 0x8088;
  public static final int TEXTURE_COORD_ARRAY_TYPE = 0x8089;
  public static final int TEXTURE_COORD_ARRAY_STRIDE = 0x808a;
  public static final int EDGE_FLAG_ARRAY_STRIDE = 0x808c;
  public static final int VERTEX_ARRAY_POINTER = 0x808e;
  public static final int NORMAL_ARRAY_POINTER = 0x808f;
  public static final int COLOR_ARRAY_POINTER = 0x8090;
  public static final int INDEX_ARRAY_POINTER = 0x8091;
  public static final int TEXTURE_COORD_ARRAY_POINTER = 0x8092;
  public static final int EDGE_FLAG_ARRAY_POINTER = 0x8093;
  public static final int V2F = 0x2a20;
  public static final int V3F = 0x2a21;
  public static final int C4UB_V2F = 0x2a22;
  public static final int C4UB_V3F = 0x2a23;
  public static final int C3F_V3F = 0x2a24;
  public static final int N3F_V3F = 0x2a25;
  public static final int C4F_N3F_V3F = 0x2a26;
  public static final int T2F_V3F = 0x2a27;
  public static final int T4F_V4F = 0x2a28;
  public static final int T2F_C4UB_V3F = 0x2a29;
  public static final int T2F_C3F_V3F = 0x2a2a;
  public static final int T2F_N3F_V3F = 0x2a2b;
  public static final int T2F_C4F_N3F_V3F = 0x2a2c;
  public static final int T4F_C4F_N3F_V4F = 0x2a2d;
  public static final int BGR = 0x80e0;
  public static final int BGRA = 0x80e1;
  public static final int CONSTANT_COLOR = 0x8001;
  public static final int ONE_MINUS_CONSTANT_COLOR = 0x8002;
  public static final int CONSTANT_ALPHA = 0x8003;
  public static final int ONE_MINUS_CONSTANT_ALPHA = 0x8004;
  public static final int BLEND_COLOR = 0x8005;
  public static final int FUNC_ADD = 0x8006;
  public static final int MIN = 0x8007;
  public static final int MAX = 0x8008;
  public static final int BLEND_EQUATION = 0x8009;
  public static final int FUNC_SUBTRACT = 0x800a;
  public static final int FUNC_REVERSE_SUBTRACT = 0x800b;
  public static final int COLOR_MATRIX = 0x80b1;
  public static final int COLOR_MATRIX_STACK_DEPTH = 0x80b2;
  public static final int MAX_COLOR_MATRIX_STACK_DEPTH = 0x80b3;
  public static final int POST_COLOR_MATRIX_RED_SCALE = 0x80b4;
  public static final int POST_COLOR_MATRIX_GREEN_SCALE = 0x80b5;
  public static final int POST_COLOR_MATRIX_BLUE_SCALE = 0x80b6;
  public static final int POST_COLOR_MATRIX_ALPHA_SCALE = 0x80b7;
  public static final int POST_COLOR_MATRIX_RED_BIAS = 0x80b8;
  public static final int POST_COLOR_MATRIX_GREEN_BIAS = 0x80b9;
  public static final int POST_COLOR_MATRIX_BLUE_BIAS = 0x80ba;
  public static final int POST_COLOR_MATRIX_ALPHA_BIAS = 0x80bb;
  public static final int COLOR_TABLE = 0x80d0;
  public static final int POST_CONVOLUTION_COLOR_TABLE = 0x80d1;
  public static final int POST_COLOR_MATRIX_COLOR_TABLE = 0x80d2;
  public static final int PROXY_COLOR_TABLE = 0x80d3;
  public static final int PROXY_POST_CONVOLUTION_COLOR_TABLE = 0x80d4;
  public static final int PROXY_POST_COLOR_MATRIX_COLOR_TABLE = 0x80d5;
  public static final int COLOR_TABLE_SCALE = 0x80d6;
  public static final int COLOR_TABLE_BIAS = 0x80d7;
  public static final int COLOR_TABLE_FORMAT = 0x80d8;
  public static final int COLOR_TABLE_WIDTH = 0x80d9;
  public static final int COLOR_TABLE_RED_SIZE = 0x80da;
  public static final int COLOR_TABLE_GREEN_SIZE = 0x80db;
  public static final int COLOR_TABLE_BLUE_SIZE = 0x80dc;
  public static final int COLOR_TABLE_ALPHA_SIZE = 0x80dd;
  public static final int COLOR_TABLE_LUMINANCE_SIZE = 0x80de;
  public static final int COLOR_TABLE_INTENSITY_SIZE = 0x80df;
  public static final int CONVOLUTION_1D = 0x8010;
  public static final int CONVOLUTION_2D = 0x8011;
  public static final int SEPARABLE_2D = 0x8012;
  public static final int CONVOLUTION_BORDER_MODE = 0x8013;
  public static final int CONVOLUTION_FILTER_SCALE = 0x8014;
  public static final int CONVOLUTION_FILTER_BIAS = 0x8015;
  public static final int REDUCE = 0x8016;
  public static final int CONVOLUTION_FORMAT = 0x8017;
  public static final int CONVOLUTION_WIDTH = 0x8018;
  public static final int CONVOLUTION_HEIGHT = 0x8019;
  public static final int MAX_CONVOLUTION_WIDTH = 0x801a;
  public static final int MAX_CONVOLUTION_HEIGHT = 0x801b;
  public static final int POST_CONVOLUTION_RED_SCALE = 0x801c;
  public static final int POST_CONVOLUTION_GREEN_SCALE = 0x801d;
  public static final int POST_CONVOLUTION_BLUE_SCALE = 0x801e;
  public static final int POST_CONVOLUTION_ALPHA_SCALE = 0x801f;
  public static final int POST_CONVOLUTION_RED_BIAS = 0x8020;
  public static final int POST_CONVOLUTION_GREEN_BIAS = 0x8021;
  public static final int POST_CONVOLUTION_BLUE_BIAS = 0x8022;
  public static final int POST_CONVOLUTION_ALPHA_BIAS = 0x8023;
  public static final int IGNORE_BORDER = 0x8150;
  public static final int CONSTANT_BORDER = 0x8151;
  public static final int REPLICATE_BORDER = 0x8153;
  public static final int CONVOLUTION_BORDER_COLOR = 0x8154;
  public static final int MAX_ELEMENTS_VERTICES = 0x80e8;
  public static final int MAX_ELEMENTS_INDICES = 0x80e9;
  public static final int HISTOGRAM = 0x8024;
  public static final int PROXY_HISTOGRAM = 0x8025;
  public static final int HISTOGRAM_WIDTH = 0x8026;
  public static final int HISTOGRAM_FORMAT = 0x8027;
  public static final int HISTOGRAM_RED_SIZE = 0x8028;
  public static final int HISTOGRAM_GREEN_SIZE = 0x8029;
  public static final int HISTOGRAM_BLUE_SIZE = 0x802a;
  public static final int HISTOGRAM_ALPHA_SIZE = 0x802b;
  public static final int HISTOGRAM_LUMINANCE_SIZE = 0x802c;
  public static final int HISTOGRAM_SINK = 0x802d;
  public static final int MINMAX = 0x802e;
  public static final int MINMAX_FORMAT = 0x802f;
  public static final int MINMAX_SINK = 0x8030;
  public static final int TABLE_TOO_LARGE = 0x8031;
  public static final int UNSIGNED_BYTE_3_3_2 = 0x8032;
  public static final int UNSIGNED_SHORT_4_4_4_4 = 0x8033;
  public static final int UNSIGNED_SHORT_5_5_5_1 = 0x8034;
  public static final int UNSIGNED_INT_8_8_8_8 = 0x8035;
  public static final int UNSIGNED_INT_10_10_10_2 = 0x8036;
  public static final int UNSIGNED_BYTE_2_3_3_REV = 0x8362;
  public static final int UNSIGNED_SHORT_5_6_5 = 0x8363;
  public static final int UNSIGNED_SHORT_5_6_5_REV = 0x8364;
  public static final int UNSIGNED_SHORT_4_4_4_4_REV = 0x8365;
  public static final int UNSIGNED_SHORT_1_5_5_5_REV = 0x8366;
  public static final int UNSIGNED_INT_8_8_8_8_REV = 0x8367;
  public static final int UNSIGNED_INT_2_10_10_10_REV = 0x8368;
  public static final int RESCALE_NORMAL = 0x803a;
  public static final int LIGHT_MODEL_COLOR_CONTROL = 0x81f8;
  public static final int SINGLE_COLOR = 0x81f9;
  public static final int SEPARATE_SPECULAR_COLOR = 0x81fa;
  public static final int PACK_SKIP_IMAGES = 0x806b;
  public static final int PACK_IMAGE_HEIGHT = 0x806c;
  public static final int UNPACK_SKIP_IMAGES = 0x806d;
  public static final int UNPACK_IMAGE_HEIGHT = 0x806e;
  public static final int TEXTURE_3D = 0x806f;
  public static final int PROXY_TEXTURE_3D = 0x8070;
  public static final int TEXTURE_DEPTH = 0x8071;
  public static final int TEXTURE_WRAP_R = 0x8072;
  public static final int MAX_3D_TEXTURE_SIZE = 0x8073;
  public static final int CLAMP_TO_EDGE = 0x812f;
  public static final int TEXTURE_MIN_LOD = 0x813a;
  public static final int TEXTURE_MAX_LOD = 0x813b;
  public static final int TEXTURE_BASE_LEVEL = 0x813c;
  public static final int TEXTURE_MAX_LEVEL = 0x813d;
  public static final int POLYGON_OFFSET_BIAS_EXT = 0x8039;
  public static final int TEXTURE_COLOR_TABLE_SGI = 0x80bc;
  public static final int PROXY_TEXTURE_COLOR_TABLE_SGI = 0x80bd;
  public static final int COMPRESSED_GEOM_ACCELERATED_SUNX = 0x81d0;
  public static final int COMPRESSED_GEOM_VERSION_SUNX = 0x81d1;
  public static final int SURFACE_SIZE_HINT_SUNX = 0x81d2;
  public static final int LARGE_SUNX = 0x81d3;
  public static final int UNPACK_CONSTANT_DATA_SUNX = 0x81d5;
  public static final int TEXTURE_CONSTANT_DATA_SUNX = 0x81d6;
  public static final int RESTART_SUN = 0x01;
  public static final int REPLACE_MIDDLE_SUN = 0x02;
  public static final int REPLACE_OLDEST_SUN = 0x03;
  public static final int TRIANGLE_LIST_SUN = 0x81d7;
  public static final int REPLACEMENT_CODE_SUN = 0x81d8;
  public static final int REPLACEMENT_CODE_ARRAY_SUN = 0x85c0;
  public static final int REPLACEMENT_CODE_ARRAY_TYPE_SUN = 0x85c1;
  public static final int REPLACEMENT_CODE_ARRAY_STRIDE_SUN = 0x85c2;
  public static final int REPLACEMENT_CODE_ARRAY_POINTER_SUN = 0x85c3;
  public static final int R1UI_V3F_SUN = 0x85c4;
  public static final int R1UI_C4UB_V3F_SUN = 0x85c5;
  public static final int R1UI_C3F_V3F_SUN = 0x85c6;
  public static final int R1UI_N3F_V3F_SUN = 0x85c7;
  public static final int R1UI_C4F_N3F_V3F_SUN = 0x85c8;
  public static final int R1UI_T2F_V3F_SUN = 0x85c9;
  public static final int R1UI_T2F_N3F_V3F_SUN = 0x85ca;
  public static final int R1UI_T2F_C4F_N3F_V3F_SUN = 0x85cb;
  public static final int OCCLUSION_TEST_HP = 0x8165;
  public static final int OCCLUSION_RESULT_HP = 0x8166;
  public static final int GLOBAL_ALPHA_SUN = 0x81d9;
  public static final int GLOBAL_ALPHA_FACTOR_SUN = 0x81da;
  public static final int ABGR_EXT = 0x8000;
  public static final int WRAP_BORDER_SUN = 0x81d4;
  public static final int PIXEL_TRANSFORM_2D_EXT = 0x8330;
  public static final int PIXEL_MAG_FILTER_EXT = 0x8331;
  public static final int PIXEL_MIN_FILTER_EXT = 0x8332;
  public static final int PIXEL_CUBIC_WEIGHT_EXT = 0x8333;
  public static final int CUBIC_EXT = 0x8334;
  public static final int AVERAGE_EXT = 0x8335;
  public static final int PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = 0x8336;
  public static final int MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = 0x8337;
  public static final int PIXEL_TRANSFORM_2D_MATRIX_EXT = 0x8338;
  public static final int PIXEL_TRANSFORM_COLOR_TABLE_EXT = 0x8339;
  public static final int PROXY_PIXEL_TRANSFORM_COLOR_TABLE_EXT = 0x833a;
}
