package gnu.x11.keysym;


/**
 * Arabic-specific keyboard symbols. Imported from
 * <code>XK_ARABIC</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x05. 
 */
public class Arabic {
  public static final int FARSI_0 = 0x590;
  public static final int FARSI_1 = 0x591;
  public static final int FARSI_2 = 0x592;
  public static final int FARSI_3 = 0x593;
  public static final int FARSI_4 = 0x594;
  public static final int FARSI_5 = 0x595;
  public static final int FARSI_6 = 0x596;
  public static final int FARSI_7 = 0x597;
  public static final int FARSI_8 = 0x598;
  public static final int FARSI_9 = 0x599;
  public static final int PERCENT = 0x5a5;
  public static final int SUPERSCRIPT_ALEF = 0x5a6;
  public static final int TTEH = 0x5a7;
  public static final int PEH = 0x5a8;
  public static final int TCHEH = 0x5a9;
  public static final int DDAL = 0x5aa;
  public static final int RREH = 0x5ab;
  public static final int COMMA = 0x5ac;
  public static final int FULLSTOP = 0x5ae;
  public static final int NUM_0 = 0x5b0;
  public static final int NUM_1 = 0x5b1;
  public static final int NUM_2 = 0x5b2;
  public static final int NUM_3 = 0x5b3;
  public static final int NUM_4 = 0x5b4;
  public static final int NUM_5 = 0x5b5;
  public static final int NUM_6 = 0x5b6;
  public static final int NUM_7 = 0x5b7;
  public static final int NUM_8 = 0x5b8;
  public static final int NUM_9 = 0x5b9;
  public static final int SEMICOLON = 0x5bb;
  public static final int QUESTION_MARK = 0x5bf;
  public static final int HAMZA = 0x5c1;
  public static final int MADDAONALEF = 0x5c2;
  public static final int HAMZAONALEF = 0x5c3;
  public static final int HAMZAONWAW = 0x5c4;
  public static final int HAMZAUNDERALEF = 0x5c5;
  public static final int HAMZAONYEH = 0x5c6;
  public static final int ALEF = 0x5c7;
  public static final int BEH = 0x5c8;
  public static final int TEHMARBUTA = 0x5c9;
  public static final int TEH = 0x5ca;
  public static final int THEH = 0x5cb;
  public static final int JEEM = 0x5cc;
  public static final int HAH = 0x5cd;
  public static final int KHAH = 0x5ce;
  public static final int DAL = 0x5cf;
  public static final int THAL = 0x5d0;
  public static final int RA = 0x5d1;
  public static final int ZAIN = 0x5d2;
  public static final int SEEN = 0x5d3;
  public static final int SHEEN = 0x5d4;
  public static final int SAD = 0x5d5;
  public static final int DAD = 0x5d6;
  public static final int TAH = 0x5d7;
  public static final int ZAH = 0x5d8;
  public static final int AIN = 0x5d9;
  public static final int GHAIN = 0x5da;
  public static final int TATWEEL = 0x5e0;
  public static final int FEH = 0x5e1;
  public static final int QAF = 0x5e2;
  public static final int KAF = 0x5e3;
  public static final int LAM = 0x5e4;
  public static final int MEEM = 0x5e5;
  public static final int NOON = 0x5e6;
  public static final int HA = 0x5e7;
  public static final int HEH = 0x5e7; /* deprecated */
  public static final int WAW = 0x5e8;
  public static final int ALEFMAKSURA = 0x5e9;
  public static final int YEH = 0x5ea;
  public static final int FATHATAN = 0x5eb;
  public static final int DAMMATAN = 0x5ec;
  public static final int KASRATAN = 0x5ed;
  public static final int FATHA = 0x5ee;
  public static final int DAMMA = 0x5ef;
  public static final int KASRA = 0x5f0;
  public static final int SHADDA = 0x5f1;
  public static final int SUKUN = 0x5f2;
  public static final int MADDA_ABOVE = 0x5f3;
  public static final int HAMZA_ABOVE = 0x5f4;
  public static final int HAMZA_BELOW = 0x5f5;
  public static final int JEH = 0x5f6;
  public static final int VEH = 0x5f7;
  public static final int KEHEH = 0x5f8;
  public static final int GAF = 0x5f9;
  public static final int NOON_GHUNNA = 0x5fa;
  public static final int HEH_DOACHASHMEE = 0x5fb;
  public static final int FARSI_YEH = 0x5fc;
  public static final int YEH_BAREE = 0x5fd;
  public static final int HEH_GOAL = 0x5fe;;
  public static final int SWITCH = 0xff7e; /* alias for mode_switch */
}
