package gnu.x11.keysym;


/**
 * Armenian-specific keyboard symbols. Imported from
 * <code>XK_ARMENIAN</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x14.
 */
public class Armenian {
  public static final int ETERNITY = 0x14a1;
  public static final int LIGATURE_EW = 0x14a2;
  public static final int FULL_STOP = 0x14a3;
  public static final int VERJAKET = 0x14a3;
  public static final int PARENRIGHT = 0x14a4;
  public static final int PARENLEFT = 0x14a5;
  public static final int GUILLEMOTRIGHT = 0x14a6;
  public static final int GUILLEMOTLEFT = 0x14a7;
  public static final int EM_DASH = 0x14a8;
  public static final int DOT = 0x14a9;
  public static final int MIJAKET = 0x14a9;
  public static final int SEPARATION_MARK = 0x14aa;
  public static final int BUT = 0x14aa;
  public static final int COMMA = 0x14ab;
  public static final int EN_DASH = 0x14ac;
  public static final int HYPHEN = 0x14ad;
  public static final int YENTAMNA = 0x14ad;
  public static final int ELLIPSIS = 0x14ae;
  public static final int EXCLAM = 0x14af;
  public static final int AMANAK = 0x14af;
  public static final int ACCENT = 0x14b0;
  public static final int SHESHT = 0x14b0;
  public static final int QUESTION = 0x14b1;
  public static final int PARUYK = 0x14b1;
  public static final int AYB = 0x14b2;
  public static final int AYB_SMALL = 0x14b3;
  public static final int BEN = 0x14b4;
  public static final int BEN_SMALL = 0x14b5;
  public static final int GIM = 0x14b6;
  public static final int GIM_SMALL = 0x14b7;
  public static final int DA = 0x14b8;
  public static final int DA_SMALL = 0x14b9;
  public static final int YECH = 0x14ba;
  public static final int YECH_SMALL = 0x14bb;
  public static final int ZA = 0x14bc;
  public static final int ZA_SMALL = 0x14bd;
  public static final int E = 0x14be;
  public static final int E_SMALL = 0x14bf;
  public static final int AT = 0x14c0;
  public static final int AT_SMALL = 0x14c1;
  public static final int TO = 0x14c2;
  public static final int TO_SMALL = 0x14c3;
  public static final int ZHE = 0x14c4;
  public static final int ZHE_SMALL = 0x14c5;
  public static final int INI = 0x14c6;
  public static final int INI_SMALL = 0x14c7;
  public static final int LYUN = 0x14c8;
  public static final int LYUN_SMALL = 0x14c9;
  public static final int KHE = 0x14ca;
  public static final int KHE_SMALL = 0x14cb;
  public static final int TSA = 0x14cc;
  public static final int TSA_SMALL = 0x14cd;
  public static final int KEN = 0x14ce;
  public static final int KEN_SMALL = 0x14cf;
  public static final int HO = 0x14d0;
  public static final int HO_SMALL = 0x14d1;
  public static final int DZA = 0x14d2;
  public static final int DZA_SMALL = 0x14d3;
  public static final int GHAT = 0x14d4;
  public static final int GHAT_SMALL = 0x14d5;
  public static final int TCHE = 0x14d6;
  public static final int TCHE_SMALL = 0x14d7;
  public static final int MEN = 0x14d8;
  public static final int MEN_SMALL = 0x14d9;
  public static final int HI = 0x14da;
  public static final int HI_SMALL = 0x14db;
  public static final int NU = 0x14dc;
  public static final int NU_SMALL = 0x14dd;
  public static final int SHA = 0x14de;
  public static final int SHA_SMALL = 0x14df;
  public static final int VO = 0x14e0;
  public static final int VO_SMALL = 0x14e1;
  public static final int CHA = 0x14e2;
  public static final int CHA_SMALL = 0x14e3;
  public static final int PE = 0x14e4;
  public static final int PE_SMALL = 0x14e5;
  public static final int JE = 0x14e6;
  public static final int JE_SMALL = 0x14e7;
  public static final int RA = 0x14e8;
  public static final int RA_SMALL = 0x14e9;
  public static final int SE = 0x14ea;
  public static final int SE_SMALL = 0x14eb;
  public static final int VEV = 0x14ec;
  public static final int VEV_SMALL = 0x14ed;
  public static final int TYUN = 0x14ee;
  public static final int TYUN_SMALL = 0x14ef;
  public static final int RE = 0x14f0;
  public static final int RE_SMALL = 0x14f1;
  public static final int TSO = 0x14f2;
  public static final int TSO_SMALL = 0x14f3;
  public static final int VYUN = 0x14f4;
  public static final int VYUN_SMALL = 0x14f5;
  public static final int PYUR = 0x14f6;
  public static final int PYUR_SMALL = 0x14f7;
  public static final int KE = 0x14f8;
  public static final int KE_SMALL = 0x14f9;
  public static final int O = 0x14fa;
  public static final int O_SMALL = 0x14fb;
  public static final int FE = 0x14fc;
  public static final int FE_SMALL = 0x14fd;
  public static final int APOSTROPHE = 0x14fe;
  public static final int SECTION_SIGN = 0x14ff;
}
