package gnu.x11.keysym;


/**
 * Caucasus-specific keyboard symbols. Imported from
 * <code>XK_CAUCASUS</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x16. 
 */
public class Caucasus {
  /* Azeri (and other Turkic or Caucasian languages of ex-USSR). */

  public static final int CCEDILLAABOVEDOT = 0x16a2;
  public static final int XABOVEDOT = 0x16a3;
  public static final int QABOVEDOT = 0x16a5;
  public static final int IBREVE = 0x16a6;
  public static final int IE = 0x16a7;
  public static final int UO = 0x16a8;
  public static final int ZSTROKE = 0x16a9;
  public static final int GCARON = 0x16aa;
  public static final int OBARRED = 0x16af;

  public static final int CCEDILLAABOVEDOT_SMALL = 0x16b2;
  public static final int XABOVEDOT_SMALL = 0x16b3;

  public static final int OCARON = 0x16b4;

  public static final int QABOVEDOT_SMALL = 0x16b5;
  public static final int IBREVE_SMALL = 0x16b6;
  public static final int IE_SMALL = 0x16b7;
  public static final int UO_SMALL = 0x16b8;
  public static final int ZSTROKE_SMALL = 0x16b9;
  public static final int GCARON_SMALL = 0x16ba;
  public static final int OCARON_SMALL = 0x16bd;
  public static final int OBARRED_SMALL = 0x16bf;

  public static final int SCHWA = 0x16c6;
  public static final int SCHWA_SMALL = 0x16f6;


  /* Inupiak (not really Caucasus). */

  public static final int LBELOWDOT = 0x16d1;
  public static final int LSTROKEBELOWDOT = 0x16d2;
  public static final int LBELOWDOT_SMALL = 0x16e1;
  public static final int LSTROKEBELOWDOT_SMALL = 0x16e2;


  /* Guarani (not really Caucasus). */

  public static final int GTILDE = 0x16d3;
  public static final int GTILDE_SMALL = 0x16e3;
}
