package gnu.x11.keysym;


/**
 * Cyrillic-specific keyboard symbols. Imported from
 * <code>XK_CYRILLIC</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x06. 
 */
public class Cyrillic {
  public static final int GHE_BAR = 0x680;
  public static final int GHE_BAR_SMALL = 0x690;
  public static final int ZHE_DESCENDER = 0x681;
  public static final int ZHE_DESCENDER_SMALL = 0x691;
  public static final int KA_DESCENDER = 0x682;
  public static final int KA_DESCENDER_SMALL = 0x692;
  public static final int KA_VERTSTROKE = 0x683;
  public static final int KA_VERTSTROKE_SMALL = 0x693;
  public static final int EN_DESCENDER = 0x684;
  public static final int EN_DESCENDER_SMALL = 0x694;
  public static final int U_STRAIGHT = 0x685;
  public static final int U_STRAIGHT_SMALL = 0x695;
  public static final int U_STRAIGHT_BAR = 0x686;
  public static final int U_STRAIGHT_BAR_SMALL = 0x696;
  public static final int HA_DESCENDER = 0x687;
  public static final int HA_DESCENDER_SMALL = 0x697;
  public static final int CHE_DESCENDER = 0x688;
  public static final int CHE_DESCENDER_SMALL = 0x698;
  public static final int CHE_VERTSTROKE = 0x689;
  public static final int CHE_VERTSTROKE_SMALL = 0x699;
  public static final int SHHA = 0x68a;
  public static final int SHHA_SMALL = 0x69a;

  public static final int SCHWA = 0x68c;
  public static final int SCHWA_SMALL = 0x69c;
  public static final int I_MACRON = 0x68d;
  public static final int I_MACRON_SMALL = 0x69d;
  public static final int O_BAR = 0x68e;
  public static final int O_BAR_SMALL = 0x69e;
  public static final int U_MACRON = 0x68f;
  public static final int U_MACRON_SMALL = 0x69f;

  public static final int SERBIAN_DJE_SMALL = 0x6a1;
  public static final int MACEDONIA_GJE_SMALL = 0x6a2;
  public static final int IO_SMALL = 0x6a3;
  public static final int UKRAINIAN_IE_SMALL = 0x6a4;
  public static final int UKRANIAN_JE_SMALL = 0x6a4; /* deprecated */
  public static final int MACEDONIA_DSE_SMALL = 0x6a5;
  public static final int UKRAINIAN_I_SMALL = 0x6a6;
  public static final int UKRANIAN_I_SMALL = 0x6a6; /* deprecated */
  public static final int UKRAINIAN_YI_SMALL = 0x6a7;
  public static final int UKRANIAN_YI_SMALL = 0x6a7; /* deprecated */
  public static final int JE_SMALL = 0x6a8;
  public static final int SERBIAN_JE_SMALL = 0x6a8; /* deprecated */
  public static final int LJE_SMALL = 0x6a9;
  public static final int SERBIAN_LJE_SMALL = 0x6a9; /* deprecated */
  public static final int NJE_SMALL = 0x6aa;
  public static final int SERBIAN_NJE_SMALL = 0x6aa; /* deprecated */
  public static final int SERBIAN_TSHE_SMALL = 0x6ab;
  public static final int MACEDONIA_KJE_SMALL = 0x6ac;
  public static final int UKRAINIAN_GHE_WITH_UPTURN_SMALL = 0x6ad;
  public static final int BYELORUSSIAN_SHORTU_SMALL = 0x6ae;
  public static final int DZHE_SMALL = 0x6af;
  public static final int SERBIAN_DZE_SMALL = 0x6af; /* deprecated */

  public static final int NUMEROSIGN = 0x6b0;
  public static final int SERBIAN_DJE = 0x6b1;
  public static final int MACEDONIA_GJE = 0x6b2;
  public static final int IO = 0x6b3;
  public static final int UKRAINIAN_IE = 0x6b4;
  public static final int UKRANIAN_JE = 0x6b4; /* deprecated */
  public static final int MACEDONIA_DSE = 0x6b5;
  public static final int UKRAINIAN_I = 0x6b6;
  public static final int UKRANIAN_I = 0x6b6; /* deprecated */
  public static final int UKRAINIAN_YI = 0x6b7;
  public static final int UKRANIAN_YI = 0x6b7; /* deprecated */
  public static final int JE = 0x6b8;
  public static final int SERBIAN_JE = 0x6b8; /* deprecated */
  public static final int LJE = 0x6b9;
  public static final int SERBIAN_LJE = 0x6b9; /* deprecated */
  public static final int NJE = 0x6ba;
  public static final int SERBIAN_NJE = 0x6ba; /* deprecated */
  public static final int SERBIAN_TSHE = 0x6bb;
  public static final int MACEDONIA_KJE = 0x6bc;
  public static final int UKRAINIAN_GHE_WITH_UPTURN = 0x6bd;
  public static final int BYELORUSSIAN_SHORTU = 0x6be;
  public static final int DZHE = 0x6bf;
  public static final int SERBIAN_DZE = 0x6bf; /* deprecated */

  public static final int YU_SMALL = 0x6c0;
  public static final int A_SMALL = 0x6c1;
  public static final int BE_SMALL = 0x6c2;
  public static final int TSE_SMALL = 0x6c3;
  public static final int DE_SMALL = 0x6c4;
  public static final int IE_SMALL = 0x6c5;
  public static final int EF_SMALL = 0x6c6;
  public static final int GHE_SMALL = 0x6c7;
  public static final int HA_SMALL = 0x6c8;
  public static final int I_SMALL = 0x6c9;
  public static final int SHORTI_SMALL = 0x6ca;
  public static final int KA_SMALL = 0x6cb;
  public static final int EL_SMALL = 0x6cc;
  public static final int EM_SMALL = 0x6cd;
  public static final int EN_SMALL = 0x6ce;
  public static final int O_SMALL = 0x6cf;
  public static final int PE_SMALL = 0x6d0;
  public static final int YA_SMALL = 0x6d1;
  public static final int ER_SMALL = 0x6d2;
  public static final int ES_SMALL = 0x6d3;
  public static final int TE_SMALL = 0x6d4;
  public static final int U_SMALL = 0x6d5;
  public static final int ZHE_SMALL = 0x6d6;
  public static final int VE_SMALL = 0x6d7;
  public static final int SOFTSIGN_SMALL = 0x6d8;
  public static final int YERU_SMALL = 0x6d9;
  public static final int ZE_SMALL = 0x6da;
  public static final int SHA_SMALL = 0x6db;
  public static final int E_SMALL = 0x6dc;
  public static final int SHCHA_SMALL = 0x6dd;
  public static final int CHE_SMALL = 0x6de;
  public static final int HARDSIGN_SMALL = 0x6df;

  public static final int YU = 0x6e0;
  public static final int A = 0x6e1;
  public static final int BE = 0x6e2;
  public static final int TSE = 0x6e3;
  public static final int DE = 0x6e4;
  public static final int IE = 0x6e5;
  public static final int EF = 0x6e6;
  public static final int GHE = 0x6e7;
  public static final int HA = 0x6e8;
  public static final int I = 0x6e9;
  public static final int SHORTI = 0x6ea;
  public static final int KA = 0x6eb;
  public static final int EL = 0x6ec;
  public static final int EM = 0x6ed;
  public static final int EN = 0x6ee;
  public static final int O = 0x6ef;
  public static final int PE = 0x6f0;
  public static final int YA = 0x6f1;
  public static final int ER = 0x6f2;
  public static final int ES = 0x6f3;
  public static final int TE = 0x6f4;
  public static final int U = 0x6f5;
  public static final int ZHE = 0x6f6;
  public static final int VE = 0x6f7;
  public static final int SOFTSIGN = 0x6f8;
  public static final int YERU = 0x6f9;
  public static final int ZE = 0x6fa;
  public static final int SHA = 0x6fb;
  public static final int E = 0x6fc;
  public static final int SHCHA = 0x6fd;
  public static final int CHE = 0x6fe;
  public static final int HARDSIGN = 0x6ff;
}
