package gnu.x11.keysym;


/**
 * Greek-specific keyboard symbols. Imported from <code>XK_GREEK</code>
 * section of <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 =
 * 0x07.
 */
public class Greek {
  public static final int ALPHA_ACCENT = 0x7a1;
  public static final int EPSILON_ACCENT = 0x7a2;
  public static final int ETA_ACCENT = 0x7a3;
  public static final int IOTA_ACCENT = 0x7a4;
  public static final int IOTA_DIERESIS = 0x7a5;
  public static final int IOTA_DIAERESIS = 0x7a7;
  public static final int UPSILON_ACCENT = 0x7a8;;
  public static final int UPSILON_DIERESIS = 0x7a9;
  public static final int OMEGA_ACCENT = 0x7ab;
  public static final int ACCENT_DIERESIS = 0x7ae;
  public static final int HORIZBAR = 0x7af;

  public static final int ALPHA_ACCENT_SMALL = 0x7b1;
  public static final int EPSILON_ACCENT_SMALL = 0x7b2;
  public static final int ETA_ACCENT_SMALL = 0x7b3;
  public static final int IOTA_ACCENT_SMALL = 0x7b4;
  public static final int IOTA_DIERESIS_SMALL = 0x7b5;
  public static final int IOTA_ACCENT_DIERESIS_SMALL = 0x7b6;
  public static final int OMICRON_ACCENT_SMALL = 0x7b7;
  public static final int UPSILON_ACCENT_SMALL = 0x7b8;
  public static final int UPSILON_DIERESIS_SMALL = 0x7b9;
  public static final int UPSILON_ACCENT_DIERESIS_SMALL = 0x7ba;
  public static final int OMEGA_ACCENT_SMALL = 0x7bb;

  public static final int ALPHA = 0x7c1;
  public static final int BETA = 0x7c2;
  public static final int GAMMA = 0x7c3;
  public static final int DELTA = 0x7c4;
  public static final int EPSILON = 0x7c5;
  public static final int ZETA = 0x7c6;
  public static final int ETA = 0x7c7;
  public static final int THETA = 0x7c8;
  public static final int IOTA = 0x7c9;
  public static final int KAPPA = 0x7ca;
  public static final int LAMDA = 0x7cb;
  public static final int LAMBDA = 0x7cb;
  public static final int MU = 0x7cc;
  public static final int NU = 0x7cd;
  public static final int XI = 0x7ce;
  public static final int OMICRON = 0x7cf;
  public static final int PI = 0x7d0;
  public static final int RHO = 0x7d1;
  public static final int SIGMA = 0x7d2;
  public static final int TAU = 0x7d4;
  public static final int UPSILON = 0x7d5;
  public static final int PHI = 0x7d6;
  public static final int CHI = 0x7d7;
  public static final int PSI = 0x7d8;
  public static final int OMEGA = 0x7d9;

  public static final int ALPHA_SMALL = 0x7e1;
  public static final int BETA_SMALL = 0x7e2;
  public static final int GAMMA_SMALL = 0x7e3;
  public static final int DELTA_SMALL = 0x7e4;
  public static final int EPSILON_SMALL = 0x7e5;
  public static final int ZETA_SMALL = 0x7e6;
  public static final int ETA_SMALL = 0x7e7;
  public static final int THETA_SMALL = 0x7e8;
  public static final int IOTA_SMALL = 0x7e9;
  public static final int KAPPA_SMALL = 0x7ea;
  public static final int LAMDA_SMALL = 0x7eb;
  public static final int LAMBDA_SMALL = 0x7eb;
  public static final int MU_SMALL = 0x7ec;
  public static final int NU_SMALL = 0x7ed;
  public static final int XI_SMALL = 0x7ee;
  public static final int OMICRON_SMALL = 0x7ef;
  public static final int PI_SMALL = 0x7f0;
  public static final int RHO_SMALL = 0x7f1;
  public static final int SIGMA_SMALL = 0x7f2;
  public static final int FINAL_SIGMA_SMALL = 0x7f3;
  public static final int TAU_SMALL = 0x7f4;
  public static final int UPSILON_SMALL = 0x7f5;
  public static final int PHI_SMALL = 0x7f6;
  public static final int CHI_SMALL = 0x7f7;
  public static final int PSI_SMALL = 0x7f8;
  public static final int OMEGA_SMALL = 0x7f9;

  public static final int SWITCH = 0xff7e; /* alias for mode_switch */
}
