package gnu.x11.keysym;


/**
 * Hebrew-specific keyboard symbols. Imported from
 * <code>XK_HEBREW</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x0c. 
 */
public class Hebrew {
  public static final int DOUBLELOWLINE = 0xcdf;
  public static final int ALEPH = 0xce0;
  public static final int BET = 0xce1;
  public static final int BETH = 0xce1; /* deprecated */
  public static final int GIMEL = 0xce2;
  public static final int GIMMEL = 0xce2; /* deprecated */
  public static final int DALET = 0xce3;
  public static final int DALETH = 0xce3; /* deprecated */
  public static final int HE = 0xce4;
  public static final int WAW = 0xce5;
  public static final int ZAIN = 0xce6;
  public static final int ZAYIN = 0xce6; /* deprecated */
  public static final int CHET = 0xce7;
  public static final int HET = 0xce7; /* deprecated */
  public static final int TET = 0xce8;
  public static final int TETH = 0xce8; /* deprecated */
  public static final int YOD = 0xce9;
  public static final int FINALKAPH = 0xcea;
  public static final int KAPH = 0xceb;
  public static final int LAMED = 0xcec;
  public static final int FINALMEM = 0xced;
  public static final int MEM = 0xcee;
  public static final int FINALNUN = 0xcef;
  public static final int NUN = 0xcf0;
  public static final int SAMECH = 0xcf1;
  public static final int SAMEKH = 0xcf1; /* deprecated */
  public static final int AYIN = 0xcf2;
  public static final int FINALPE = 0xcf3;
  public static final int PE = 0xcf4;
  public static final int FINALZADE = 0xcf5;
  public static final int FINALZADI = 0xcf5; /* deprecated */
  public static final int ZADE = 0xcf6;
  public static final int ZADI = 0xcf6; /* deprecated */
  public static final int QOPH = 0xcf7;
  public static final int KUF = 0xcf7; /* deprecated */
  public static final int RESH = 0xcf8;
  public static final int SHIN = 0xcf9;
  public static final int TAW = 0xcfa;
  public static final int TAF = 0xcfa; /* deprecated */
  public static final int SWITCH = 0xff7e; /* alias for mode_switch */
}
