package gnu.x11.keysym;


/**
 * Katakana-specific keyboard symbols. Imported from
 * <code>XK_KATAKANA</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x04. 
 */
public class Katakana {
  public static final int YDIAERESIS = 0x13be;
  public static final int OVERLINE = 0x47e;
  public static final int FULL_STOP = 0x4a1;
  public static final int OPENING_BRACKET = 0x4a2;
  public static final int CLOSING_BRACKET = 0x4a3;
  public static final int COMMA = 0x4a4;
  public static final int CONJUNCTIVE = 0x4a5;
  public static final int MIDDLE_DOT = 0x4a5; /* deprecated */
  public static final int WO = 0x4a6;

  public static final int A_SMALL = 0x4a7;
  public static final int I_SMALL = 0x4a8;
  public static final int U_SMALL = 0x4a9;
  public static final int E_SMALL = 0x4aa;
  public static final int O_SMALL = 0x4ab;
  public static final int YA_SMALL = 0x4ac;
  public static final int YU_SMALL = 0x4ad;
  public static final int YO_SMALL = 0x4ae;
  public static final int TSU_SMALL = 0x4af;
  public static final int TU_SMALL = 0x4af; /* deprecated */

  public static final int PROLONGED_SOUND = 0x4b0;
  public static final int A = 0x4b1;
  public static final int I = 0x4b2;
  public static final int U = 0x4b3;
  public static final int E = 0x4b4;
  public static final int O = 0x4b5;
  public static final int KA = 0x4b6;
  public static final int KI = 0x4b7;
  public static final int KU = 0x4b8;
  public static final int KE = 0x4b9;
  public static final int KO = 0x4ba;
  public static final int SA = 0x4bb;
  public static final int SHI = 0x4bc;
  public static final int SU = 0x4bd;
  public static final int SE = 0x4be;
  public static final int SO = 0x4bf;
  public static final int TA = 0x4c0;
  public static final int CHI = 0x4c1;
  public static final int TI = 0x4c1; /* deprecated */
  public static final int TSU = 0x4c2;
  public static final int TU = 0x4c2; /* deprecated */
  public static final int TE = 0x4c3;
  public static final int TO = 0x4c4;
  public static final int NA = 0x4c5;
  public static final int NI = 0x4c6;
  public static final int NU = 0x4c7;
  public static final int NE = 0x4c8;
  public static final int NO = 0x4c9;
  public static final int HA = 0x4ca;
  public static final int HI = 0x4cb;
  public static final int FU = 0x4cc;
  public static final int HU = 0x4cc; /* deprecated */
  public static final int HE = 0x4cd;
  public static final int HO = 0x4ce;
  public static final int MA = 0x4cf;
  public static final int MI = 0x4d0;
  public static final int MU = 0x4d1;
  public static final int ME = 0x4d2;
  public static final int MO = 0x4d3;

  public static final int YA = 0x4d4;
  public static final int YU = 0x4d5;
  public static final int YO = 0x4d6;

  public static final int RA = 0x4d7;
  public static final int RI = 0x4d8;
  public static final int RU = 0x4d9;
  public static final int RE = 0x4da;
  public static final int RO = 0x4db;
  public static final int WA = 0x4dc;
  public static final int N = 0x4dd;
  public static final int VOICED_SOUND = 0x4de;
  public static final int SEMI_VOICED_SOUND = 0x4df;
  public static final int SWITCH = 0xff7e; /* alias for mode_switch */
}
