package gnu.x11.keysym;


/**
 * Latin 1-specific keyboard symbols. Imported from
 * <code>XK_LATIN1</code> section of
 * <code>/usr/include/X11/X11/keysymdef.h</code>. 
 * Note that byte 3 = 0x00.
 */
public class Latin1 {
  public static final int SPACE = 0x020;
  public static final int EXCLAM = 0x021;
  public static final int QUOTE_DBL = 0x022;
  public static final int NUMBER_SIGN = 0x023;
  public static final int DOLLAR = 0x024;
  public static final int PERCENT = 0x025;
  public static final int AMPERSAND = 0x026;
  public static final int APOSTROPHE = 0x027;
  public static final int QUOTE_RIGHT = 0x027; /* deprecated */
  public static final int PAREN_LEFT = 0x028;
  public static final int PAREN_RIGHT = 0x029;
  public static final int ASTERISK = 0x02a;
  public static final int PLUS = 0x02b;
  public static final int COMMA = 0x02c;
  public static final int MINUS = 0x02d;
  public static final int PERIOD = 0x02e;
  public static final int SLASH = 0x02f;
  public static final int NUM_0 = 0x030;
  public static final int NUM_1 = 0x031;
  public static final int NUM_2 = 0x032;
  public static final int NUM_3 = 0x033;
  public static final int NUM_4 = 0x034;
  public static final int NUM_5 = 0x035;
  public static final int NUM_6 = 0x036;
  public static final int NUM_7 = 0x037;
  public static final int NUM_8 = 0x038;
  public static final int NUM_9 = 0x039;
  public static final int COLON = 0x03a;
  public static final int SEMICOLON = 0x03b;
  public static final int LESS = 0x03c;
  public static final int EQUAL = 0x03d;
  public static final int GREATER = 0x03e;
  public static final int QUESTION = 0x03f;
  public static final int AT = 0x040;
  public static final int A = 0x041;
  public static final int B = 0x042;
  public static final int C = 0x043;
  public static final int D = 0x044;
  public static final int E = 0x045;
  public static final int F = 0x046;
  public static final int G = 0x047;
  public static final int H = 0x048;
  public static final int I = 0x049;
  public static final int J = 0x04a;
  public static final int K = 0x04b;
  public static final int L = 0x04c;
  public static final int M = 0x04d;
  public static final int N = 0x04e;
  public static final int O = 0x04f;
  public static final int P = 0x050;
  public static final int Q = 0x051;
  public static final int R = 0x052;
  public static final int S = 0x053;
  public static final int T = 0x054;
  public static final int U = 0x055;
  public static final int V = 0x056;
  public static final int W = 0x057;
  public static final int X = 0x058;
  public static final int Y = 0x059;
  public static final int Z = 0x05a;
  public static final int BRACKET_LEFT = 0x05b;
  public static final int BACKSLASH = 0x05c;
  public static final int BRACKET_RIGHT = 0x05d;
  public static final int ASCII_CIRCUM = 0x05e;
  public static final int UNDERSCORE = 0x05f;
  public static final int GRAVE = 0x060;
  public static final int QUOTE_LEFT = 0x060; /* deprecated */

  public static final int A_SMALL = 0x061;
  public static final int B_SMALL = 0x062;
  public static final int C_SMALL = 0x063;
  public static final int D_SMALL = 0x064;
  public static final int E_SMALL = 0x065;
  public static final int F_SMALL = 0x066;
  public static final int G_SMALL = 0x067;
  public static final int H_SMALL = 0x068;
  public static final int I_SMALL = 0x069;
  public static final int J_SMALL = 0x06a;
  public static final int K_SMALL = 0x06b;
  public static final int L_SMALL = 0x06c;
  public static final int M_SMALL = 0x06d;
  public static final int N_SMALL = 0x06e;
  public static final int O_SMALL = 0x06f;
  public static final int P_SMALL = 0x070;
  public static final int Q_SMALL = 0x071;
  public static final int R_SMALL = 0x072;
  public static final int S_SMALL = 0x073;
  public static final int T_SMALL = 0x074;
  public static final int U_SMALL = 0x075;
  public static final int V_SMALL = 0x076;
  public static final int W_SMALL = 0x077;
  public static final int X_SMALL = 0x078;
  public static final int Y_SMALL = 0x079;
  public static final int Z_SMALL = 0x07a;

  public static final int BRACE_LEFT = 0x07b;
  public static final int BAR = 0x07c;
  public static final int BRACE_RIGHT = 0x07d;
  public static final int ASCII_TILDE = 0x07e;

  public static final int NO_BREAKSPACE = 0x0a0;;
  public static final int EXCLAM_DOWN = 0x0a1;
  public static final int CENT = 0x0a2;
  public static final int STERLING = 0x0a3;
  public static final int CURRENCY = 0x0a4;
  public static final int YEN = 0x0a5;
  public static final int BROKEN_BAR = 0x0a6;
  public static final int SECTION = 0x0a7;
  public static final int DIAERESIS = 0x0a8;
  public static final int COPYRIGHT = 0x0a9;
  public static final int ORDFEMININE = 0x0aa;
  public static final int GUILLEMOT_LEFT = 0x0ab; /* left angle quotation mark */
  public static final int NOT_SIGN = 0x0ac;
  public static final int HYPHEN = 0x0ad;
  public static final int REGISTERED = 0x0ae;
  public static final int MACRON = 0x0af;
  public static final int DEGREE = 0x0b0;
  public static final int PLUS_MINUS = 0x0b1;
  public static final int TWO_SUPERIOR = 0x0b2;
  public static final int THREE_SUPERIOR = 0x0b3;
  public static final int ACUTE = 0x0b4;
  public static final int MU = 0x0b5;
  public static final int PARAGRAPH = 0x0b6;
  public static final int PERIOD_CENTERED = 0x0b7;
  public static final int CEDILLA = 0x0b8;
  public static final int ONE_SUPERIOR = 0x0b9;
  public static final int MASCULINE = 0x0ba;
  public static final int GUILLEMOT_RIGHT = 0x0bb; /* right angle quotation mark */
  public static final int ONE_QUARTER = 0x0bc;
  public static final int ONE_HALF = 0x0bd;
  public static final int THREE_QUARTERS = 0x0be;
  public static final int QUESTION_DOWN = 0x0bf;
  public static final int A_GRAVE = 0x0c0;
  public static final int A_ACUTE = 0x0c1;
  public static final int A_CIRCUMFLEX = 0x0c2;
  public static final int A_TILDE = 0x0c3;
  public static final int A_DIAERESIS = 0x0c4;
  public static final int A_RING = 0x0c5;
  public static final int AE = 0x0c6;
  public static final int C_CEDILLA = 0x0c7;
  public static final int E_GRAVE = 0x0c8;
  public static final int E_ACUTE = 0x0c9;
  public static final int E_CIRCUMFLEX = 0x0ca;
  public static final int E_DIAERESIS = 0x0cb;
  public static final int I_GRAVE = 0x0cc;
  public static final int I_ACUTE = 0x0cd;
  public static final int I_CIRCUMFLEX = 0x0ce;
  public static final int I_DIAERESIS = 0x0cf;
  public static final int E_TH = 0x0d0;
  public static final int N_TILDE = 0x0d1;
  public static final int O_GRAVE = 0x0d2;
  public static final int O_ACUTE = 0x0d3;
  public static final int O_CIRCUMFLEX = 0x0d4;
  public static final int O_TILDE = 0x0d5;
  public static final int O_DIAERESIS = 0x0d6;
  public static final int MULTIPLY = 0x0d7;
  public static final int O_OBLIQUE = 0x0d8;
  public static final int O_SLASH = 0x0d9;
  public static final int U_ACUTE = 0x0da;;
  public static final int U_CIRCUMFLEX = 0x0db;
  public static final int U_DIAERESIS = 0x0dc;
  public static final int Y_ACUTE = 0x0dd;
  public static final int T_HORN = 0x0de;
  public static final int S_SHARP = 0x0df;

  public static final int A_GRAVE_SMALL = 0x0e0;
  public static final int A_ACUTE_SMALL = 0x0e1;
  public static final int A_CIRCUMFLEX_SMALL = 0x0e2;
  public static final int A_TILDE_SMALL = 0x0e3;
  public static final int A_DIAERESIS_SMALL = 0x0e4;
  public static final int A_RING_SMALL = 0x0e5;
  public static final int AE_SMALL = 0x0e6;
  public static final int C_CEDILLA_SMALL = 0x0e7;
  public static final int E_GRAVE_SMALL = 0x0e8;
  public static final int E_ACUTE_SMALL = 0x0e9;
  public static final int E_CIRCUMFLEX_SMALL = 0x0ea;
  public static final int E_DIAERESIS_SMALL = 0x0eb;
  public static final int I_GRAVE_SMALL = 0x0ec;
  public static final int I_ACUTE_SMALL = 0x0ed;
  public static final int I_CIRCUMFLEX_SMALL = 0x0ee;
  public static final int I_DIAERESIS_SMALL = 0x0ef;
  public static final int E_TH_SMALL = 0x0f0;
  public static final int N_TILDE_SMALL = 0x0f1;
  public static final int O_GRAVE_SMALL = 0x0f2;
  public static final int O_ACUTE_SMALL = 0x0f3;
  public static final int O_CIRCUMFLEX_SMALL = 0x0f4;
  public static final int O_TILDE_SMALL = 0x0f5;
  public static final int O_DIAERESIS_SMALL = 0x0f6;
  public static final int DIVISION_SMALL = 0x0f7;
  public static final int O_SLASH_SMALL = 0x0f8;
  public static final int O_OBLIQUE_SMALL = 0x0f9;
  public static final int UA_CUTE_SMALL = 0x0fa;;
  public static final int U_CIRCUMFLEX_SMALL = 0x0fb;
  public static final int U_DIAERESIS_SMALL = 0x0fc;
  public static final int YA_CUTE_SMALL = 0x0fd;
  public static final int T_HORN_SMALL = 0x0fe;
  public static final int Y_DIAERESIS_SMALL = 0x0ff;
}
