package gnu.x11.keysym;


/**
 * Latin 2-specific keyboard symbols. Imported from
 * <code>XK_LATIN2</code> section of <code>/usr/include/X11/keysymdef.h</code>. 
 * Note that byte 3 = 0x01.
 */
public class Latin2 {
  public static final int AOGONEK = 0x1a1;
  public static final int BREVE = 0x1a2;
  public static final int LSTROKE = 0x1a3;
  public static final int LCARON = 0x1a5;
  public static final int SACUTE = 0x1a6;
  public static final int SCARON = 0x1a9;
  public static final int SCEDILLA = 0x1aa;
  public static final int TCARON = 0x1ab;
  public static final int ZACUTE = 0x1ac;
  public static final int ZCARON = 0x1ae;
  public static final int ZABOVEDOT = 0x1af;

  public static final int AOGONEK_SMALL = 0x1b1;
  public static final int OGONEK_SMALL = 0x1b2;
  public static final int LSTROKE_SMALL = 0x1b3;
  public static final int LCARON_SMALL = 0x1b5;
  public static final int SACUTE_SMALL = 0x1b6;
  public static final int CARON_SMALL = 0x1b7;
  public static final int SCARON_SMALL = 0x1b9;
  public static final int SCEDILLA_SMALL = 0x1ba;
  public static final int TCARON_SMALL = 0x1bb;
  public static final int ZACUTE_SMALL = 0x1bc;
  public static final int DOUBLEACUTE_SMALL = 0x1bd;
  public static final int ZCARON_SMALL = 0x1be;
  public static final int ZABOVEDOT_SMALL = 0x1bf;

  public static final int RACUTE = 0x1c0;
  public static final int ABREVE = 0x1c3;
  public static final int LACUTE = 0x1c5;
  public static final int CACUTE = 0x1c6;
  public static final int CCARON = 0x1c8;
  public static final int EOGONEK = 0x1ca;
  public static final int ECARON = 0x1cc;
  public static final int DCARON = 0x1cf;
  public static final int DSTROKE = 0x1d0;
  public static final int NACUTE = 0x1d1;
  public static final int NCARON = 0x1d2;
  public static final int ODOUBLEACUTE = 0x1d5;
  public static final int RCARON = 0x1d8;
  public static final int URING = 0x1d9;
  public static final int UDOUBLEACUTE = 0x1db;
  public static final int TCEDILLA = 0x1de;

  public static final int RACUTE_SMALL = 0x1e0;
  public static final int ABREVE_SMALL = 0x1e3;
  public static final int LACUTE_SMALL = 0x1e5;
  public static final int CACUTE_SMALL = 0x1e6;
  public static final int CCARON_SMALL = 0x1e8;
  public static final int EOGONEK_SMALL = 0x1ea;
  public static final int ECARON_SMALL = 0x1ec;
  public static final int DCARON_SMALL = 0x1ef;
  public static final int DSTROKE_SMALL = 0x1f0;
  public static final int NACUTE_SMALL = 0x1f1;
  public static final int NCARON_SMALL = 0x1f2;
  public static final int ODOUBLEACUTE_SMALL = 0x1f5;
  public static final int UDOUBLEACUTE_SMALL = 0x1fb;
  public static final int RCARON_SMALL = 0x1f8;
  public static final int URING_SMALL = 0x1f9;
  public static final int TCEDILLA_SMALL = 0x1fe;
  public static final int ABOVEDOT_SMALL = 0x1ff;
}
