package gnu.x11.keysym;


/**
 * Latin 3-specific keyboard symbols. Imported from
 * <code>XK_LATIN3</code> section of <code>/usr/include/X11/keysymdef.h</code>. 
 * Note that byte 3 = 0x02.
 */
public class Latin3 {
  public static final int HSTROKE = 0x2a1;;
  public static final int HCIRCUMFLEX = 0x2a6;
  public static final int IABOVEDOT = 0x2a9;
  public static final int GBREVE = 0x2ab;
  public static final int JCIRCUMFLEX = 0x2ac;

  public static final int HSTROKE_SMALL = 0x2b1;
  public static final int HCIRCUMFLEX_SMALL = 0x2b6;
  public static final int IDOTLESS_SMALL = 0x2b9;
  public static final int GBREVE_SMALL = 0x2bb;
  public static final int JCIRCUMFLEX_SMALL = 0x2bc;

  public static final int CABOVEDOT = 0x2c5;
  public static final int CCIRCUMFLEX = 0x2c6;
  public static final int GABOVEDOT = 0x2d5;
  public static final int GCIRCUMFLEX = 0x2d8;
  public static final int UBREVE = 0x2dd;
  public static final int SCIRCUMFLEX = 0x2de;

  public static final int CABOVEDOT_SMALL = 0x2e5;
  public static final int CCIRCUMFLEX_SMALL = 0x2e6;
  public static final int GABOVEDOT_SMALL = 0x2f5;
  public static final int GCIRCUMFLEX_SMALL = 0x2f8;
  public static final int UBREVE_SMALL = 0x2fd;
  public static final int SCIRCUMFLEX_SMALL = 0x2fe;
}
