package gnu.x11.keysym;


/**
 * Latin 4-specific keyboard symbols. Imported from
 * <code>XK_LATIN4</code> section of <code>/usr/include/X11/keysymdef.h</code>. 
 * Note that byte 3 = 0x03.
 */
public class Latin4 {
  public static final int KRA = 0x3a2;
  public static final int KAPPA = 0x3a2; /* deprecated */
  public static final int RCEDILLA = 0x3a3;
  public static final int ITILDE = 0x3a5;
  public static final int LCEDILLA = 0x3a6;
  public static final int EMACRON = 0x3aa;
  public static final int GCEDILLA = 0x3ab;
  public static final int TSLASH = 0x3ac;

  public static final int RCEDILLA_SMALL = 0x3b3;
  public static final int ITILDE_SMALL = 0x3b5;
  public static final int LCEDILLA_SMALL = 0x3b6;
  public static final int EMACRON_SMALL = 0x3ba;
  public static final int GCEDILLA_SMALL = 0x3bb;
  public static final int TSLASH_SMALL = 0x3bc;

  public static final int ENG = 0x3bd;
  public static final int ENG_SMALL = 0x3bf;

  public static final int AMACRON = 0x3c0;
  public static final int IOGONEK = 0x3c7;
  public static final int EABOVEDOT = 0x3cc;
  public static final int IMACRON = 0x3cf;
  public static final int NCEDILLA = 0x3d1;
  public static final int OMACRON = 0x3d2;
  public static final int KCEDILLA = 0x3d3;
  public static final int UOGONEK = 0x3d9;
  public static final int UTILDE = 0x3dd;
  public static final int UMACRON = 0x3de;

  public static final int AMACRON_SMALL = 0x3e0;
  public static final int IOGONEK_SMALL = 0x3e7;
  public static final int EABOVEDOT_SMALL = 0x3ec;
  public static final int IMACRON_SMALL = 0x3ef;
  public static final int NCEDILLA_SMALL = 0x3f1;
  public static final int OMACRON_SMALL = 0x3f2;
  public static final int KCEDILLA_SMALL = 0x3f3;
  public static final int UOGONEK_SMALL = 0x3f9;
  public static final int UTILDE_SMALL = 0x3fd;
  public static final int UMACRON_SMALL = 0x3fe;
}
