package gnu.x11.keysym;


/**
 * Publishing-specific keyboard symbols. Imported from
 * <code>XK_PUBLISHING</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x0a. 
 */
public class Publishing {
  public static final int EMSPACE = 0xaa1;
  public static final int ENSPACE = 0xaa2;
  public static final int EM3SPACE = 0xaa3;
  public static final int EM4SPACE = 0xaa4;
  public static final int DIGIT_SPACE = 0xaa5;
  public static final int PUNCT_SPACE = 0xaa6;
  public static final int THIN_SPACE = 0xaa7;
  public static final int HAIR_SPACE = 0xaa8;
  public static final int EMDASH = 0xaa9;
  public static final int ENDASH = 0xaaa;
  public static final int SIGN_IF_BLANK = 0xaac;
  public static final int ELLIPSIS = 0xaae;
  public static final int DOUB_BASE_LINE_DOT = 0xaaf;
  public static final int ONE_THIRD = 0xab0;
  public static final int TWO_THIRDS = 0xab1;
  public static final int ONE_FIFTH = 0xab2;
  public static final int TWO_FIFTHS = 0xab3;
  public static final int THREE_FIFTHS = 0xab4;
  public static final int FOUR_FIFTHS = 0xab5;
  public static final int ONE_SIXTH = 0xab6;
  public static final int FIVE_SIXTHS = 0xab7;
  public static final int CARE_OF = 0xab8;
  public static final int FIG_DASH = 0xabb;
  public static final int LEFT_ANGLE_BRACKET = 0xabc;
  public static final int DECIMAL_POINT = 0xabd;
  public static final int RIGH_TANGLE_BRACKET = 0xabe;
  public static final int MARKER = 0xabf;
  public static final int ONE_EIGHTH = 0xac3;
  public static final int THREE_EIGHTHS = 0xac4;
  public static final int FIVE_EIGHTHS = 0xac5;
  public static final int SEVEN_EIGHTHS = 0xac6;
  public static final int TRADEMARK = 0xac9;
  public static final int SIGNATURE_MARK = 0xaca;
  public static final int TRADEMARK_IN_CIRCLE = 0xacb;
  public static final int LEFT_OPEN_TRIANGLE = 0xacc;
  public static final int RIGHT_OPEN_TRIANGLE = 0xacd;
  public static final int EM_OPEN_CIRCLE = 0xace;
  public static final int EM_OPEN_RECTANGLE = 0xacf;
  public static final int LEFT_SINGLE_QUOTE_MARK = 0xad0;
  public static final int RIGHT_SINGLE_QUOTE_MARK = 0xad1;
  public static final int LEFT_DOUBLE_QUOTE_MARK = 0xad2;
  public static final int RIGHT_DOUBLE_QUOTE_MARK = 0xad3;
  public static final int PRESCRIPTION = 0xad4;
  public static final int MINUTES = 0xad6;
  public static final int SECONDS = 0xad7;
  public static final int LATIN_CROSS = 0xad9;
  public static final int HEXAGRAM = 0xada;
  public static final int FILLED_RECT_BULLET = 0xadb;
  public static final int FILLED_LEFT_TRI_BULLET = 0xadc;
  public static final int FILLED_RIGHT_TRI_BULLET = 0xadd;
  public static final int EM_FILLED_CIRCLE = 0xade;
  public static final int EM_FILLED_RECT = 0xadf;
  public static final int EN_OPEN_CIRC_BULLET = 0xae0;
  public static final int EN_OPEN_SQUARE_BULLET = 0xae1;
  public static final int OPEN_RECT_BULLET = 0xae2;
  public static final int OPEN_TRI_BULLET_UP = 0xae3;
  public static final int OPEN_TRI_BULLET_DOWN = 0xae4;
  public static final int OPEN_STAR = 0xae5;
  public static final int EN_FILLED_CIRC_BULLET = 0xae6;
  public static final int EN_FILLED_SQ_BULLET = 0xae7;
  public static final int FILLED_TRI_BULLET_UP = 0xae8;
  public static final int FILLED_TRI_BULLET_DOWN = 0xae9;
  public static final int LEFT_POINTER = 0xaea;
  public static final int RIGHT_POINTER = 0xaeb;
  public static final int CLUB = 0xaec;
  public static final int DIAMOND = 0xaed;
  public static final int HEART = 0xaee;
  public static final int MALTESE_CROSS = 0xaf0;
  public static final int DAGGER = 0xaf1;
  public static final int DOUBLE_DAGGER = 0xaf2;
  public static final int CHECKMARK = 0xaf3;
  public static final int BALLOT_CROSS = 0xaf4;
  public static final int MUSICAL_SHARP = 0xaf5;
  public static final int MUSICAL_FLAT = 0xaf6;
  public static final int MALE_SYMBOL = 0xaf7;
  public static final int FEMALE_SYMBOL = 0xaf8;
  public static final int TELEPHONE = 0xaf9;
  public static final int TELEPHONE_RECORDER = 0xafa;
  public static final int PHONOGRAPH_COPYRIGHT = 0xafb;
  public static final int CARET = 0xafc;
  public static final int SINGLE_LOW_QUOTE_MARK = 0xafd;
  public static final int DOUBLE_LOW_QUOTE_MARK = 0xafe;
  public static final int CURSOR = 0xaff;
}
