package gnu.x11.keysym;


/**
 * Technical-specific keyboard symbols. Imported from
 * <code>XK_TECHNICAL</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x08. 
 */
public class Technical {
  public static final int LEFT_RADICAL = 0x8a1;
  public static final int TOP_LEFT_RADICAL = 0x8a2;
  public static final int HORIZ_CONNECTOR = 0x8a3;
  public static final int TOP_INTEGRAL = 0x8a4;
  public static final int BOT_INTEGRAL = 0x8a5;
  public static final int VERT_CONNECTOR = 0x8a6;
  public static final int TOP_LEFT_SQ_BRACKET = 0x8a7;
  public static final int BOT_LEFT_SQ_BRACKET = 0x8a8;
  public static final int TOP_RIGHT_SQ_BRACKET = 0x8a9;
  public static final int BOT_RIGHT_SQ_BRACKET = 0x8aa;
  public static final int TOP_LEFT_PARENS = 0x8ab;
  public static final int BOT_LEFT_PARENS = 0x8ac;
  public static final int TOP_RIGHT_PARENS = 0x8ad;
  public static final int BOT_RIGHT_PARENS = 0x8ae;
  public static final int LEFT_MIDDLE_CURLYBRACE = 0x8af;
  public static final int RIGHT_MIDDLE_CURLYBRACE = 0x8b0;
  public static final int TOP_LEFT_SUMMATION = 0x8b1;
  public static final int BOT_LEFT_SUMMATION = 0x8b2;
  public static final int TOP_VERT_SUMMATION_CONNECTOR = 0x8b3;
  public static final int BOT_VERT_SUMMATION_CONNECTOR = 0x8b4;
  public static final int TOP_RIGHT_SUMMATION = 0x8b5;
  public static final int BOT_RIGHT_SUMMATION = 0x8b6;
  public static final int RIGHT_MIDDLE_SUMMATION = 0x8b7;
  public static final int LESS_THAN_EQUAL = 0x8bc;
  public static final int NOT_EQUAL = 0x8bd;
  public static final int GREATER_THAN_EQUAL = 0x8be;
  public static final int INTEGRAL = 0x8bf;
  public static final int THEREFORE = 0x8c0;
  public static final int VARIATION = 0x8c1;
  public static final int INFINITY = 0x8c2;
  public static final int NABLA = 0x8c5;
  public static final int APPROXIMATE = 0x8c8;
  public static final int SIMILAR_EQUAL = 0x8c9;
  public static final int IF_ONLY_IF = 0x8cd;
  public static final int IMPLIES = 0x8ce;
  public static final int IDENTICAL = 0x8cf;
  public static final int RADICAL = 0x8d6;
  public static final int INCLUDED_IN = 0x8da;
  public static final int INCLUDES = 0x8db;
  public static final int INTERSECTION = 0x8dc;
  public static final int UNION = 0x8dd;
  public static final int LOGICAL_AND = 0x8de;
  public static final int LOGICAL_OR = 0x8df;
  public static final int PARTIAL_DERIVATIVE = 0x8ef;
  public static final int FUNCTION = 0x8f6;
  public static final int LEFT_ARROW = 0x8fb;
  public static final int UP_ARROW = 0x8fc;
  public static final int RIGHT_ARROW = 0x8fd;
  public static final int DOWN_ARROW = 0x8fe;
}
