
package gnu.x11.keysym;


/**
 * Vietnamese-specific keyboard symbols. Imported from
 * <code>XK_VIETNAMESE</code> section of
 * <code>/usr/include/X11/keysymdef.h</code>. Note that byte 3 = 0x1e. 
 */
public class Vietnamese {
  public static final int ABELOWDOT = 0x1ea0;
  public static final int ABELOWDOT_SMALL = 0x1ea1;
  public static final int AHOOK = 0x1ea2;
  public static final int AHOOK_SMALL = 0x1ea3;
  public static final int ACIRCUMFLEXACUTE = 0x1ea4;
  public static final int ACIRCUMFLEXACUTE_SMALL = 0x1ea5;
  public static final int ACIRCUMFLEXGRAVE = 0x1ea6;
  public static final int ACIRCUMFLEXGRAVE_SMALL = 0x1ea7;
  public static final int ACIRCUMFLEXHOOK = 0x1ea8;
  public static final int ACIRCUMFLEXHOOK_SMALL = 0x1ea9;
  public static final int ACIRCUMFLEXTILDE = 0x1eaa;
  public static final int ACIRCUMFLEXTILDE_SMALL = 0x1eab;
  public static final int ACIRCUMFLEXBELOWDOT = 0x1eac;
  public static final int ACIRCUMFLEXBELOWDOT_SMALL = 0x1ead;
  public static final int ABREVEACUTE = 0x1eae;
  public static final int ABREVEACUTE_SMALL = 0x1eaf;
  public static final int ABREVEGRAVE = 0x1eb0;
  public static final int ABREVEGRAVE_SMALL = 0x1eb1;
  public static final int ABREVEHOOK = 0x1eb2;
  public static final int ABREVEHOOK_SMALL = 0x1eb3;
  public static final int ABREVETILDE = 0x1eb4;
  public static final int ABREVETILDE_SMALL = 0x1eb5;
  public static final int ABREVEBELOWDOT = 0x1eb6;
  public static final int ABREVEBELOWDOT_SMALL = 0x1eb7;
  public static final int EBELOWDOT = 0x1eb8;
  public static final int EBELOWDOT_SMALL = 0x1eb9;
  public static final int EHOOK = 0x1eba;
  public static final int EHOOK_SMALL = 0x1ebb;
  public static final int ETILDE = 0x1ebc;
  public static final int ETILDE_SMALL = 0x1ebd;
  public static final int ECIRCUMFLEXACUTE = 0x1ebe;
  public static final int ECIRCUMFLEXACUTE_SMALL = 0x1ebf;
  public static final int ECIRCUMFLEXGRAVE = 0x1ec0;
  public static final int ECIRCUMFLEXGRAVE_SMALL = 0x1ec1;
  public static final int ECIRCUMFLEXHOOK = 0x1ec2;
  public static final int ECIRCUMFLEXHOOK_SMALL = 0x1ec3;
  public static final int ECIRCUMFLEXTILDE = 0x1ec4;
  public static final int ECIRCUMFLEXTILDE_SMALL = 0x1ec5;
  public static final int ECIRCUMFLEXBELOWDOT = 0x1ec6;
  public static final int ECIRCUMFLEXBELOWDOT_SMALL = 0x1ec7;
  public static final int IHOOK = 0x1ec8;
  public static final int IHOOK_SMALL = 0x1ec9;
  public static final int IBELOWDOT = 0x1eca;
  public static final int IBELOWDOT_SMALL = 0x1ecb;
  public static final int OBELOWDOT = 0x1ecc;
  public static final int OBELOWDOT_SMALL = 0x1ecd;
  public static final int OHOOK = 0x1ece;
  public static final int OHOOK_SMALL = 0x1ecf;
  public static final int OCIRCUMFLEXACUTE = 0x1ed0;
  public static final int OCIRCUMFLEXACUTE_SMALL = 0x1ed1;
  public static final int OCIRCUMFLEXGRAVE = 0x1ed2;
  public static final int OCIRCUMFLEXGRAVE_SMALL = 0x1ed3;
  public static final int OCIRCUMFLEXHOOK = 0x1ed4;
  public static final int OCIRCUMFLEXHOOK_SMALL = 0x1ed5;
  public static final int OCIRCUMFLEXTILDE = 0x1ed6;
  public static final int OCIRCUMFLEXTILDE_SMALL = 0x1ed7;
  public static final int OCIRCUMFLEXBELOWDOT = 0x1ed8;
  public static final int OCIRCUMFLEXBELOWDOT_SMALL = 0x1ed9;
  public static final int OHORNACUTE = 0x1eda;
  public static final int OHORNACUTE_SMALL = 0x1edb;
  public static final int OHORNGRAVE = 0x1edc;
  public static final int OHORNGRAVE_SMALL = 0x1edd;
  public static final int OHORNHOOK = 0x1ede;
  public static final int OHORNHOOK_SMALL = 0x1edf;
  public static final int OHORNTILDE = 0x1ee0;
  public static final int OHORNTILDE_SMALL = 0x1ee1;
  public static final int OHORNBELOWDOT = 0x1ee2;
  public static final int OHORNBELOWDOT_SMALL = 0x1ee3;
  public static final int UBELOWDOT = 0x1ee4;
  public static final int UBELOWDOT_SMALL = 0x1ee5;
  public static final int UHOOK = 0x1ee6;
  public static final int UHOOK_SMALL = 0x1ee7;
  public static final int UHORNACUTE = 0x1ee8;
  public static final int UHORNACUTE_SMALL = 0x1ee9;
  public static final int UHORNGRAVE = 0x1eea;
  public static final int UHORNGRAVE_SMALL = 0x1eeb;
  public static final int UHORNHOOK = 0x1eec;
  public static final int UHORNHOOK_SMALL = 0x1eed;
  public static final int UHORNTILDE = 0x1eee;
  public static final int UHORNTILDE_SMALL = 0x1eef;
  public static final int UHORNBELOWDOT = 0x1ef0;
  public static final int UHORNBELOWDOT_SMALL = 0x1ef1;
  public static final int YBELOWDOT = 0x1ef4;
  public static final int YBELOWDOT_SMALL = 0x1ef5;
  public static final int YHOOK = 0x1ef6;
  public static final int YHOOK_SMALL = 0x1ef7;
  public static final int YTILDE = 0x1ef8;
  public static final int YTILDE_SMALL = 0x1ef9;
  public static final int OHORN = 0x1efa; /* u+01a0 */
  public static final int OHORN_SMALL = 0x1efb; /* u+01a1 */
  public static final int UHORN = 0x1efc; /* u+01af */
  public static final int UHORN_SMALL = 0x1efd; /* u+01b0 */

  public static final int COMBINING_TILDE = 0x1e9f; /* u+0303 */
  public static final int COMBINING_GRAVE = 0x1ef2; /* u+0300 */
  public static final int COMBINING_ACUTE = 0x1ef3; /* u+0301 */
  public static final int COMBINING_HOOK = 0x1efe; /* u+0309 */
  public static final int COMBINING_BELOWDOT = 0x1eff; /* u+0323 */
}
